Advanced setup manual
# Chapter 4 Fresh IDE setup and configuration.

## Linux setup

    Working in Linux needs [Wine] installation. Wine v4.10 or later is recommended, because an important
bug was fixed, concerning drag&drop operations.

    Actually currently, Fresh IDE works better in Linux than in Windows, because in Linux both Linux and Windows
applications can be created, while on Windows, developing Linux applications is much harder or even impossible.

I am expecting something to be changed with the upcomming WSLv2 in Windows 10, but currently, if you want to 
be able to create portable code or Linux and Windows programs, the recommended OS is Linux.

[Wine] https://www.winehq.org/

### Install Wine

    Install Wine - use whatever package manager is good for you. Synaptic is the usual choice for Ubuntu based distributions, but
Wine is available in any distribution software repository.

    There is no need to configure Wine in some special way. The default settings usually work fine.

    One possible problem can be the installed fonts for some of the Fresh IDE themes. Simply select the editor font according to 
your personal preferences from the "Options|IDE options|Editor options" dialog.


### Install Fresh IDE

    Install Fresh IDE - you can use the installation package or simply unpack the ZIP
archive somewhere. 

It is better to install Fresh IDE in "c:\" (because of the shorter paths) but it can work in any directory.

### Debuggers

    Install whatever debuggers you will use for Linux and Windows programs.

Personally I prefer and recommend [OllyDbg] for Windows and [EDB] for Linux programming. But every other will do the job.

[OllyDbg] http://www.ollydbg.de/
[EDB] https://github.com/eteran/edb-debugger

### Configure Fresh IDE

Run Fresh IDE and if some paths are not set properly, set them manually in
"Options|IDE options|Aliases" applet.

    You will need at least following directory aliases: "Fresh", "finc" and "lib" - set
them respectively to the Fresh main directory, Fresh "include" directory and "freshlib"
directory, both located in Fresh main directory. (As a rule, there is an auto setup of these
paths, so you don't to have to make it manually. But sometimes the algorithm fails)

    In order to work with FASM examples and programs, you can set manually "include" or any
other alias (environment variable) you prefer. (Note: Fresh IDE itself does not use "include" exactly because of the
vanilla FASM compatibility)

### External tools

    Set the paths to the external tools needed: (of course you have to install these
tools in advance).

    In "Options|IDE options|External tools" leave "andLinux directory" and
"andLinux shared directory" fields empty. (they are not needed when Fresh runs in Linux)

    Set "Linux debugger" field to the path of binary file of the debugger you prefer. Add the needed
options to the line as well.

    For example, in my settings "Linux debugger" is set to `z:/usr/bin/edb --run`

    Set "Linux terminal" to preferred terminal. For example `z:/usr/bin/xterm -hold +mesg`.

    Set "Win32 external debugger" to OllyDbg. In my case: `c:\Program files\OllyDebugger\Ollydbg.exe`.

    The paths can be "dos style" or "linux style" - Wine understands both. Notice that Wine maps Linux file system to device `Z:`

### Test it

    Try to compile and run some test applications both for Windows and Linux.
Ctrl+F9 should compile, Shift+F9 should run the application and Shift+F8 should load it
in the respective debugger. The type of the application should be automatically determined.


## Windows setup

    There was several attempts to make Fresh IDE to be able to run and debug Linux programs in Windows.
It was possible before, by using [andLinux] products. 

But this project is closed now and the latest version doesn't work on 64bit Windows. So, right now it is 
impossible to develop Linux (and generally portable) programs in Windows. 

Use Linux instead.

Maybe something will be changed with the upcomming WSLv2 that should be able to run 32bit Linux ELF 
binaries. This help file will be updated if this happens.

[andLinux] http://andlinux.org

