; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: IPC constants for libC functions.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


IPC_PRIVATE = 0

IPC_W       = $080
IPC_R       = $100
IPC_CREAT   = $200
IPC_EXCL    = $400
IPC_NOWAIT  = $800

IPC_RMID     =   0       ; remove identifier
IPC_SET      =   1       ; set options
IPC_STAT     =   2       ; get options
IPC_INFO     =   3

IPC_64 = $100

struct ipc_perm
  .key          dd ?
  .uid          dw ?      ;   owner euid and egid
  .gid          dw ?      ;
  .cuid         dw ?      ;   creator euid and egid
  .cgid         dw ?      ;
  .mode         dw ?      ;   access modes see mode flags below
  .seq          dw ?      ;   slot usage sequence number
ends


struct shmid_ds
  .shm_perm    ipc_perm ; Ownership and permissions
  .shm_segsz   dd ? ; Size of segment (bytes)
  .shm_atime   dd ? ; Last attach time
  .shm_dtime   dd ? ; Last detach time
  .shm_ctime   dd ? ; Last change time
  .shm_cpid    dw ? ; PID of creator
  .shm_lpid    dw ? ; PID of last SHMAT/SHMDT
  .shm_nattch  dw ? ; Number of current attaches
  .shm_unused  dw ? ; Not used
  .shm_unused2 dd ? ; Not used
  .shm_unused3 dd ? ; Not used
ends


struct ipc64_perm
  .key          dd ?
  .uid          dd ?      ;   owner euid and egid
  .gid          dd ?      ;
  .cuid         dd ?      ;   creator euid and egid
  .cgid         dd ?      ;
  .mode         dd ?      ;   access modes see mode flags below (only lower 16 bit are used)
  .seq          dd ?      ;   slot usage sequence number (only lower 16 bit are used)
                dd ?
                dd ?
ends


struct shmid64_ds
  .shm_perm    ipc64_perm ; Ownership and permissions
  .shm_segsz   dd ? ; Size of segment (bytes)
  .shm_atime   dq ? ; Last attach time
  .shm_dtime   dq ? ; Last detach time
  .shm_ctime   dq ? ; Last change time
  .shm_cpid    dd ? ; PID of creator
  .shm_lpid    dd ? ; PID of last SHMAT/SHMDT
  .shm_nattch  dd ? ; Number of current attaches
               dd ? ; Not used
               dd ? ; Not used
ends