; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: All GUI libraries combined include.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: Includes all GUI libraries at once.
;_________________________________________________________________________________________

AlignLeft   = 0
AlignRight  = 1
AlignTop    = 2
AlignBottom = 3

include 'sysevents.asm'

include 'mouse.asm'
include 'textcaret.asm'

; OS independent support code

; Limited support for the old visual editor. Contains only macro definitions.
;include 'OldTemplates.inc'

; OS independent components

include 'TObject.asm'
include 'TApplication.asm'
include 'TAction.asm'
include 'TActionList.asm'

include 'TWindow.asm'
include 'TScrollable.asm'
include 'TCanvasWindow.asm'

include 'TForm.asm'
include 'TButton.asm'
include 'TCheckbox.asm'
include 'TEdit.asm'
include 'TLabel.asm'
include 'TImageLabel.asm'
include 'TMenu.asm'
include 'TProgressbar.asm'
include 'TTreeView.asm'
include 'TToolbar.asm'
include 'TTabBar.asm'
include 'TGrid.asm'
include 'TListView.asm'

include 'dialogs.asm'
include 'file_dialogs.asm'

include 'SplitGrid.asm'

; OS independent main procedures.
include 'Main.asm'

; OS independent template engine.
include 'ObjTemplates.asm'

; Way to change the GUI themes in Runtime.
include 'themes.asm'

match theme, ThemeGUI {
  include 'themes/'#`theme#'.asm'
}

;include 'themes/flat_gui.asm'
;include 'themes/win_gui.asm'
