iglobal
  if used _FileDialogTemplate

     __file_dialog_titles dd ttlOpenDialog, ttlSaveDialog

     ttlOpenDialog text "Open file"
     ttlSaveDialog text "Save file"

    _FileDialogTemplate:
        ObjTemplate  tfParent or tfEnd, TForm, frmFileDlg,   \
                     width = 640, height = 480, border = borderModal, \
                     SplitGrid = _filegrid,                           \
                     PaddingLeft = 8, PaddingRight = 8,               \
                     PaddingTop = 8, PaddingBottom = 8

           ObjTemplate tfChild, TTabBar, .tbPath, Visible = TRUE, SplitCell = _filegrid.cellPath
           ObjTemplate tfChild, TEdit, .editFilename, Visible = TRUE, SplitCell = _filegrid.cellEdit
           ObjTemplate tfChild, TListView, .lvFiles, SplitCell = _filegrid.cellList, Style = lvsDetails, OnFocusChange = __FileListFocusChange
           ObjTemplate tfChild, TButton, .btnOK, Visible = TRUE, SplitCell = _filegrid.cellOK, TextAlign = dtfAlignCenter  or dtfAlignMiddle, Caption = 'OK', ModalResult = mrOK
           ObjTemplate tfEnd,   TButton, .btnCancel, Visible = TRUE, SplitCell = _filegrid.cellCancel, TextAlign = dtfAlignCenter or dtfAlignMiddle, Caption = 'Cancel', ModalResult = mrCancel

    SplitStart _filegrid
      Split stVert or stJustGap, 8, 24, 0, 100
        Cell cellPath
        Split stVert or stJustGap, 8, 24, 0, 100
          Cell cellEdit
          Split stVert or stJustGap or stOriginBR, 8, 24, 0, 100
            Cell cellList
            Split stHoriz or stJustGap or stOriginBR, 8, 64, 0, 100
              Split stHoriz or stJustGap or stOriginBR, 8, 64, 0, 100
                Cell empty
                Cell cellCancel
              Cell cellOK
    SplitEnd
  end if
endg




fdtOpenFile = 0
fdtSaveFile = 1
fdtMultipleSelect = 2

; Returns:
; 1. [.type] and fdtMultipleSelect == 0
;  eax - handle of a string with the full pathname of the file.
; 2. [.type] and fdtMultipleSelect <> 0
;  eax - pointer to TArray of dword with the filenames.

proc FileDialog, .pParent, .type, .start_dir, .filters_list,
begin
        pushad
        stdcall CreateFromTemplate, _FileDialogTemplate, 0

        mov     eax, [.type]
        and     eax, 1
        set     ebx, TForm:Caption, [__file_dialog_titles+4*eax]

        xor     eax, eax
        mov     esi, [frmFileDlg.lvFiles]
        mov     [esi+TListView.FixedCols], eax
        inc     eax
        mov     [esi+TListView.FixedRows], eax

        mov     eax, gfGridLinesFixed or gfResizeColumns or gfRowFocus
        test    [.type], fdtMultipleSelect
        jnz     @f
        or      eax, gfSingleCellSelect
@@:
        set     esi, TListView:Flags, eax

        exec    esi, TListView:AddHeader, txt "Filename"
        exec    esi, TListView:AddHeader, txt "Size"
        exec    esi, TListView:AddHeader, txt "Type"
        exec    esi, TListView:AddHeader, txt "Modified"

        set     [frmFileDlg.tbPath], TTabBar:OnSelChange, __FileDlgPathChanged

        stdcall GetFullPathName, [.start_dir]
        push    eax eax

        stdcall StrPtr, eax
        cmp     byte [eax], DIR_SLASH
        jne     @f
        exec    [frmFileDlg.tbPath], TTabBar:InsertTab, -1, txt DIR_SLASH, 0, 0
@@:
        pop     eax
        stdcall StrSplitList, eax, DIR_SLASH, FALSE
        stdcall StrDel ; from the stack
        mov     edx, eax
        xor     ecx, ecx

.dir_loop:
        cmp     ecx, [edx+TArray.count]
        jae     .end_dir

        stdcall StrCat, [edx+TArray.array+4*ecx], txt DIR_SLASH
        exec    [frmFileDlg.tbPath], TTabBar:InsertTab, -1, [edx+TArray.array+4*ecx], 0, 0
        inc     ecx
        jmp     .dir_loop

.end_dir:
        stdcall ListFree, edx, StrDel

        mov     ecx, [frmFileDlg.tbPath]
        mov     ecx, [ecx+TTabBar._items]
        mov     ecx, [ecx+TArray.count]
        dec     ecx
        set     [frmFileDlg.tbPath], TTabBar:Selected, ecx

        stdcall ShowModal, ebx, [.pParent]
        cmp     eax, mrOK
        jne     .ignore

; finish ok:

        mov     edi, [frmFileDlg.tbPath]
        mov     edx, [edi+TTabBar._items]
        mov     ecx, [edi+TTabBar._selected]
        lea     edx, [edx+TArray.array]

        stdcall StrNew
        mov     edi, eax

.restore_path:
        stdcall StrCat, edi, [edx+TTab.caption]
        add     edx, sizeof.TTab
        dec     ecx
        jns     .restore_path

        test    [.type], fdtMultipleSelect
        jnz     .get_multiple

        get     eax, [frmFileDlg.editFilename], TEdit:Text
        push    eax

        stdcall StrCat, edi, eax
        stdcall StrDel ; from the stack.

        mov     [esp+4*regEAX], edi

.finish:
        destroy ebx
        clc
        popad
        return


.get_multiple:
locals
  .path dd ?
  .end  dd ?
endl

        stdcall CreateArray, 4
        jc      .cant_allocate_array

        push    ebx

        mov     edx, eax
        mov     [.path], edi

        mov     esi, [frmFileDlg.lvFiles]
        mov     ebx, [esi+TListView._items]
        lea     ebx, [ebx+TArray.array]

        mov     ecx, [esi+TListView.selection.top]
        mov     eax, [esi+TListView.selection.bottom]

        cmp     ecx, eax
        jle     .order_ok
        xchg    ecx, eax
.order_ok:

        dec     ecx
        js      .end_files

        dec     eax     ; because of the header line!
        js      .end_files

        mov     [.end], eax

        OutputValue "Item from: ", ecx, 10, -1
        OutputValue "Item to: ", [.end], 10, -1

        lea     ebx, [ebx+8*ecx]
        lea     ebx, [ebx+8*ecx]        ; sizeof.TLvItem = $10

.file_loop:
        cmp     ecx, [.end]
        jg      .end_files

        stdcall StrDup, [.path]
        mov     edi, [ebx+TLvItem.captions]
        stdcall StrCat, eax, [edi+TArray.array]
        push    eax

        stdcall AddArrayItems, edx, 1
        pop     dword [eax]

        add     ebx, sizeof.TLvItem
        inc     ecx
        jmp     .file_loop

.end_files:
        stdcall StrDel, [.path]

        pop     ebx
        mov     [esp+4*regEAX], edx
        jmp     .finish

.cant_allocate_array:

        stdcall StrDel, edi

.ignore:
        xor     eax, eax
        mov     [esp+4*regEAX], eax
        destroy ebx
        stc
        popad
        return

endp




proc __FileDlgPathChanged as TTabBar.OnSelChange        ; , .self, .pTab, .iTab, .change
begin
        cmp     [.change], selSelected
        jne     .finish

        mov     esi, [.self]

; create active path

        stdcall StrNew
        mov     ebx, eax

        mov     edi, [esi+TTabBar._items]
        mov     ecx, [edi+TArray.count]
        dec     ecx
        js      .dir_ok

        cmp     ecx, [esi+TTabBar._selected]
        cmova   ecx, [esi+TTabBar._selected]
        lea     edi, [edi+TArray.array]

.loop:
        stdcall StrCat, ebx, [edi + TTab.caption]
        add     edi, sizeof.TTab
        dec     ecx
        jns     .loop

.dir_ok:
        stdcall __FillListView, ebx, [frmFileDlg.lvFiles]
        stdcall StrDel, ebx

.finish:
        return
endp



proc __FillListView, .hDir, .list_view
.date_time TDateTime
begin
        pushad

        mov     edi, [.list_view]

        set     edi, TListView:Visible, FALSE
        exec    edi, TListView:Clear

        stdcall DirectoryRead, [.hDir]
        jc      .finish

        mov     esi, eax        ; TArray of TDirItem
        push    eax

        stdcall SortArray, esi, DirItemCompare, dsByName or fdsDirsFirst

        mov     ecx, [esi+TArray.count]
        lea     esi, [esi+TArray.array]

.loop:
        dec     ecx
        js      .end_of_files

        xor     eax, eax
        xor     ebx, ebx

        mov     edx, [esi+TDirItem.Type]
        test    edx, ftLinkMask
        setnz   bl

        and     edx, not ftLinkMask

        cmp     edx, ftDirectory
        cmove   eax, [GUI.iconDirectory+8*ebx]

        cmp     edx, ftFile
        cmove   eax, [GUI.iconFile+8*ebx]

        mov     ebx, [edi+TListView._items]
        test    ebx, ebx
        jz      @f
        mov     ebx, [ebx+TArray.count]
@@:
        exec    edi, TListView:InsertItem, -1, [esi+TDirItem.hFilename], eax, 0

; size
        mov     edx, [esi+TDirItem.Type]
        and     edx, not ftLinkMask
        cmp     edx, ftDirectory
        jne     .get_size

        stdcall StrNew
        jmp     .set_size

.get_size:
        stdcall NumToStr64, dword [esi+TDirItem.Size], dword [esi+TDirItem.Size+4], ntsDec or ntsUnsigned

.set_size:
        push    eax
        exec    edi, TListView:AddSubItem, ebx, eax
        stdcall StrDel ; from the stack

; extension

        cmp     edx, ftDirectory
        jne     .get_ext

        stdcall StrDupMem, txt "DIR"
        jmp     .set_type

.get_ext:
        stdcall StrExtractExt, [esi+TDirItem.hFilename]
        jnc     .set_type

        stdcall StrNew

.set_type:
        push    eax
        exec    edi, TListView:AddSubItem, ebx, eax
        stdcall StrDel ; from the stack

; time modified

        lea     eax, [.date_time]
        lea     edx, [esi+TDirItem.mTime]
        stdcall TimeToDateTime, edx, eax
        stdcall DateTimeToStr, eax, 0
        push    eax
        exec    edi, TListView:AddSubItem, ebx, eax
        stdcall StrDel ; from the stack

        add     esi, sizeof.TDirItem
        jmp     .loop

.end_of_files:

        stdcall FreeDirArray ; from the stack

.finish:
        set     edi, TListView:Visible, TRUE
        popad
        return
endp





proc __FileListFocusChange as TListView.OnFocusChange
begin
        pushad

        mov     esi, [.pListView]
        mov     edx, [esi+TListView._items]

        mov     ebx, [.y]
        sub     ebx, [esi+TListView.FixedRows]
        js      .finish

        test    [esi+TListView._flags], gfRowFocus
        jnz     @f
        imul    ebx, [esi+TListView.ColCount]
        add     ebx, [.x]
        sub     ebx, [esi+TListView.FixedCols]
@@:

; here ebx is the item index in TArray

        cmp     ebx, [edx+TArray.count]
        jae     .finish

        imul    ebx, sizeof.TLvItem
        lea     ebx, [edx+ebx+TArray.array]

        mov     edx, [ebx+TLvItem.captions]

        set     [frmFileDlg.editFilename], TEdit:Text, [edx+TArray.array]

.finish:
        popad
        return
endp