; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: This file contains procedures and data, that form the appearance of the
;               FreshLib GUI application. Colors, control borders, backgrownd drawing etc.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: The user should be able to change these settings and if he uses external
;         procedures, then the code from this library should not be compiled.
;_________________________________________________________________________________________
module "GUI theme data and code library"

; Named theme colors

; cyan
clTurquoise = $ff1abc9c
clTurquoiseL = $ff31e2bf
clTurquoiseD = $ff138670

clGreenSea  = $ff16A085

; green
clEmerald   = $ff2ecc71
clNephritis = $ff27ae60

; blue

clPetermann = $ff3498db
clBelizeHole = $ff2980b9

; purple

clAmethyst = $ff9b59b6
clWisteria = $ff8e44ad

; black

clWetAsphalt = $ff34495e
clMidnight = $ff2c3e50

; gray

clConcrete = $ff95a5a6
clAsbestos = $ff7f8c8d

; light gray / white

clClouds = $ffecf0f1
clSilver = $ffbdc3c7
clWhite  = $ffffffff

; Yellow / orange

clSunflower = $fff1c40f
clOrange = $fff39c12

; Brown / orange

clCarrot = $ffe67e22
clPumpkin = $ffd35400

; Red

clAlizarin =    $ffe74c3c
clPomegranate = $ffc0392b

clBelizeClouds = $ffc9dce7 ; a blend between clBelizeHole and clClouds

iglobal

        NamedArray      GUI,                                           \
\
\ ; Text caret color
                clTextCaret,       HEX, clAlizarin,                     \       ;(clAlizarin and $00ffffff) or $e0000000,                    \
                caretTimes,        NUM, <250, 250>,                    \
\ ; Widgets border colors and width
                clBorderNeutral,   HEX, clTurquoise,                   \
                clBorderLight,     HEX, clTurquoiseL,                      \
                clBorderDark,      HEX, clTurquoiseD,                  \
                clBorderNeutralGray, HEX, $ff606060,                   \
                clBorderLightGray, HEX, $ff808080,                     \
                clBorderDarkGray,  HEX, $ff404040,                     \
                clBorderFocused,   HEX, clAlizarin,                    \
\
                boxBorderWidth,  NUM, 2,                               \
\
\ ; TButton colors and styles. The multivalue fields are for Neutral, Hovered and Pressed states.
\
               clBtnBk,         HEX, <clTurquoise, $ff48c9b0, clGreenSea, $807b7b7b>,   \
               clBtnTxt,        HEX, <clWhite, clWhite, clSilver, $80ffffff>,           \
               btnBorder,       NUM, <bxNone, bxNone, bxNone, bxNone or bxDisabled>,    \
               btnPressedOfsX,  NUM, 0,                                      \
               btnPressedOfsY,  NUM, 0,                                      \
               btnMarginX,      NUM, 8,                                      \
               btnMarginY,      NUM, 8,                                      \
\
\ ; Toolbar buttons colors and styles
               clToolBtnBk,     HEX, <clClouds, clBelizeClouds, clBelizeClouds, clClouds>,   \
               clToolBtnTxt,    HEX, <$ff000000, $ff000000, $ff000000, $80000000>,           \
               tbBorder,        NUM, <bxNone, bxNone, bxNone, bxNone or bxDisabled>,         \
               tbBorderWidth,   NUM, 1,                                      \
               tbPressedOfsX,   NUM, 0,                                      \
               tbPressedOfsY,   NUM, 2,                                      \
               tbSeparatorType,  HEX, bxFlat or bxDisabled,                  \
               tbSeparatorWidth, NUM, 10,                                     \
\
\ ; TEdit colors and styles.
\
               clEditBk,          HEX, clClouds,                                \
               clEditBkFocused,   HEX, clWhite,                                 \
               clEditTxt,         HEX, $ff000000,                               \
               clEditSel,         HEX, clBelizeHole and $00ffffff or $60000000, \
               clEditSelTxt,      HEX, $ffffffff,                               \
               editBorder,        NUM, bxFlat,                                  \
               editBorderFocused, NUM, bxFlat,                                  \
\
\ ; Dialog boxes and TForm color and styles
\
               clDialogBk,        HEX, clClouds,                             \
               clDialogTxt,       HEX, $ff000000,                            \
               clSplitter,        HEX, clWetAsphalt,                          \
\
\ ; TProgress colors and styles
\
              clProgressBk,       HEX, clClouds,                             \
              clProgressBar,      HEX, clTurquoise,                          \
              progressBorder,     NUM, bxFlat,                               \
\
\ ; TScrollbar colors and styles
\
              clScrollBk,         HEX, <clSilver and $3fffffff, clSilver and $a0ffffff>,     \
              clScrollSlider,     HEX, <clAsbestos and $7fffffff, clTurquoise>,              \
              clScrollSliderOvf,  HEX, <clOrange and $3fffffff, clOrange>,                \
              borderScroll,       NUM, bxNone,                                               \
              scrollWidth,        NUM, 12,                                                   \
              minSliderHeight,    NUM, 24,                                                   \
\
\ ; TLabel colors and styles
\
              clLabelBk,          HEX, clClouds,                                             \
              clLabelTxt,         HEX, $ff000000,                                            \
\
\ ; TTreeView colors and styles.
\
              clTreeViewBack,     HEX, $ffffffff,                                            \
              clTreeViewText,     HEX, $ff000000,                                            \
              clTreeSelected,     HEX, clBelizeHole,                                         \
              clTreeSelectedTxt,  HEX, clWhite,                                              \
              clTreeFocused,      HEX, clPumpkin,                                            \
              clTreeFocusedTxt,   HEX, clWhite,                                              \
\
              tvBorder,           NUM, bxFlat,                                               \
\
              tvIcons,            PNG, <"%lib%/gui/images/treeview/right.png", "%lib%/gui/images/treeview/down.png">,     \
\
\ ; TMenu colors and styles
\
              clMenuBack,         HEX, clClouds,                                             \
              clMenuText,         HEX, $ff000000,                                            \
              clMenuTextGray,     HEX, $90000000,                                            \
              clMenuSelection,    HEX, clBelizeHole,                                         \
              clMenuSelIcon,      HEX, clBelizeClouds,                                       \
              borderMenu,         NUM, bxFlat,                                               \
              menuIconMargin,     NUM, 4,                                                    \
              menuSeparatorHeight,NUM, 12,                                                   \
              menuMinTextDist,    NUM, 32,                                                   \
              menuSubIcon,        PNG, "%lib%/gui/images/menu/submenu.png",                  \
              menuSubIconSel,     PNG, "%lib%/gui/images/menu/submenusel.png",               \
              menuSubIconGray,    PNG, "%lib%/gui/images/menu/submenugray.png",              \
\
\ ; Menu graphics
\
              iconMenuChecked,    PNG, "%lib%/gui/images/menu/check_flat.png",               \
              iconMenuCheckedGray, PNG, "%lib%/gui/images/menu/check_flat_gray.png",         \
\
\ ; Checkbox colors
\
              clCheckboxBack,     HEX, <$ffe0e0e0, $ffffffff, $ffc0c0c0, $80c0c0c0>,         \
              clCheckboxTxt,      HEX, $ff000000,                                            \
              clCheckboxTxtGray,  HEX, $ff606060,                                            \
              cbIconSize,         NUM, 13,                                                   \
              cbMargin,           NUM, 2,                                                    \
              borderCheckbox,     NUM, bxFlat,                                               \
              iconChecked,        PNG, "%lib%/gui/images/checkbox/check_flat.png",           \
              iconCheckedGray,    PNG, "%lib%/gui/images/checkbox/check_flat_gray.png",      \
\
\ ; TabBar control
\
              maxTabWidth,        NUM, 180,                                                  \
              tabMarginX,         NUM, 4,                                                    \
              tabMarginY,         NUM, 4,                                                    \
              clTabBk,            HEX, <clClouds, clBelizeClouds, clBelizeClouds>,           \
              clTabTxt,           HEX, $ff000000,                                            \
\
\ ; Grid control
              clGridCellBk,       HEX, <$ffffffff, clClouds, clBelizeClouds, clPumpkin>,     \ ; <regular, fixed, selected, focused> background color.
              clGridCellTxt,      HEX, <$ff000000, $ff000000, $ff000000, $ffffffff>,         \ ; <regular, fixed, selected, focused> foreground color.
              clGridLines,        HEX, <$00000000, $ffc0c0c0, $00000000, clTurquoise>,       \ ;top-left data, bottom-right data, top-left fixed, bottom-right fixed.
\
\ ; ListView control
              lvIconMargin,       NUM, 2,                                                    \
\
\ ; Dialogs images
\
              iconDialogs,        PNG, <"%lib%/gui/themes/images/msgbox/error.png", "%lib%/gui/themes/images/msgbox/information.png", "%lib%/gui/themes/images/msgbox/question.png", "%lib%/gui/themes/images/msgbox/warning.png">, \
              iconDirectory,      PNG, <"%lib%/gui/themes/images/files/dir_light.png", "%lib%/gui/themes/images/files/dir_link_light.png">,                                                                                         \
              iconFile,           PNG, <"%lib%/gui/themes/images/files/file_light.png", "%lib%/gui/themes/images/files/file_link_light.png">,                                                                                       \
\
\ ; Default font
\
              DefaultFont,        FONT, "Liberation Sans": 13 : fwDemibold : 0
endg






endmodule
