; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: This file contains procedures and data, that form the appearance of the
;               FreshLib GUI application. Colors, control borders, backgrownd drawing etc.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: The user should be able to change these settings and if he uses external
;         procedures, then the code from this library should not be compiled.
;_________________________________________________________________________________________
module "GUI theme data and code library"


; Theme colors and other parameters as margins, offsets, fonts, etc.
iglobal


        NamedArray      GUI,                                    \
\
\ ; Text caret color
                clTextCaret,       HEX, $ffff0000,              \        ;$0000ffff,                   \
                caretTimes,        NUM, <250, 250>,                  \
\ ; Widgets border colors and width
                clBorderNeutral, HEX, $ffa0a0a0,                     \
                clBorderLight,   HEX, $ffffffff,                     \
                clBorderDark,    HEX, $ff404040,                     \
                clBorderNeutralGray, HEX, $ff909090,                   \
                clBorderLightGray, HEX, $ffe0e0e0,                     \
                clBorderDarkGray,  HEX, $ff808080,                     \
                clBorderFocused, HEX, $ffff8000,                     \
\
                boxBorderWidth,  NUM, 1,                             \
\
\ ; TButton colors and styles. The multivalue fields are for Neutral, Hovered and Pressed states.
\
               clBtnBk,         HEX, <$ffd4d0c8, $ffe0e0e0, $ffa0a0a0, $80d4d0c8>,      \
               clBtnTxt,        HEX, <$ff000000, $ff000000, $ff000000, $ff606060>,           \
               btnBorder,       NUM, <bxRaised, bxRaised, bxSunken, bxRaised or bxDisabled>,               \
               btnPressedOfsX,  NUM, 1,                                      \
               btnPressedOfsY,  NUM, 1,                                      \
               btnMarginX,      NUM, 8,                                      \
               btnMarginY,      NUM, 8,                                      \
\
\ ; Toolbar buttons colors and styles
               clToolBtnBk,     HEX, <$ffd4d0c8, $ffe0e0e0, $ffa0a0a0, $80d4d0c8>,              \
               clToolBtnTxt,    HEX, <$ff000000, $ff000000, $ff000000, $ff606060>,              \
               tbBorder,        NUM, <bxNone, bxRaised, bxSunken, bxNone or bxDisabled>,        \
               tbBorderWidth,   NUM, 1,                                      \
               tbPressedOfsX,   NUM, 1,                                      \
               tbPressedOfsY,   NUM, 1,                                      \
               tbSeparatorType,  HEX, bxSunken,                              \
               tbSeparatorWidth, NUM, 10,                                    \
\
\ ; TEdit colors and styles.
\
               clEditBk,          HEX, $ffffffff,                            \
               clEditBkFocused,   HEX, $ffffffff,                            \
               clEditTxt,         HEX, $ff000000,                            \
               clEditSel,         HEX, $600a246c,                            \
               clEditSelTxt,      HEX, $ffffffff,                            \
               editBorder,        NUM, bxSunken,                             \
               editBorderFocused, NUM, bxSunken,                             \
\
\ ; Dialog boxes and TForm color and styles
\
               clDialogBk,        HEX, $ffd4d0c8,                            \
               clDialogTxt,       HEX, $ff000000,                            \
               clSplitter,        HEX, $ff606060,                            \
\
\ ; TProgress colors and styles
\
              clProgressBk,       HEX, $ffd4d0c8,                            \
              clProgressBar,      HEX, $ff0a246c,                            \
              progressBorder,     NUM, bxSunken,                             \
\
\ ; TScrollbar colors and styles
\
              clScrollBk,         HEX, <$80d4d0c8, $d0d4d0c8>,                               \
              clScrollSlider,     HEX, <$c0808080, $ff808080>,                               \
              clScrollSliderOvf,  HEX, <$c0ff8080, $ffff8080>,                               \
              borderScroll,       NUM, bxRaised,                                             \
              scrollWidth,        NUM, 12,                                                   \
              minSliderHeight,    NUM, 24,                                                   \
\
\ ; TLabel colors and styles
\
              clLabelBk,          HEX, $00ffffff,                                            \
              clLabelTxt,         HEX, $ff000000,                                            \
\
\ ; TTreeView colors and styles.
\
              clTreeViewBack,     HEX, $ffffffff,                                            \
              clTreeViewText,     HEX, $ff000000,                                            \
              clTreeSelected,     HEX, $ff0a246c,                                            \
              clTreeSelectedTxt,  HEX, $ffffffff,                                            \
              clTreeFocused,      HEX, $ff0a246c,                                            \
              clTreeFocusedTxt,   HEX, $ffffff00,                                            \
\
              tvBorder,           NUM, bxSunken,                                             \
\
              tvIcons,            PNG, <"%lib%/gui/images/treeview/plus.png", "%lib%/gui/images/treeview/minus.png">,     \
\
\ ; TMenu colors and styles
\
              clMenuBack,         HEX, $ffd4d0c8,                                            \
              clMenuText,         HEX, $ff000000,                                            \
              clMenuTextGray,     HEX, $80000000,                                            \
              clMenuSelection,    HEX, $ff000080,                                            \
              clMenuSelIcon,      HEX, $ffadaabb,                                            \
              borderMenu,         NUM, bxRaised,                                             \
              menuIconMargin,     NUM, 4,                                                    \
              menuSeparatorHeight,NUM, 10,                                                   \
              menuMinTextDist,    NUM, 32,                                                   \
              menuSubIcon,        PNG, "%lib%/gui/images/menu/submenu.png",                  \
              menuSubIconSel,     PNG, "%lib%/gui/images/menu/submenusel.png",               \
              menuSubIconGray,    PNG, "%lib%/gui/images/menu/submenugray.png",              \
\
\ ; Menu graphics
\
              iconMenuChecked,    PNG, "%lib%/gui/images/menu/check.png",                    \
              iconMenuCheckedGray,PNG, "%lib%/gui/images/menu/check_gray.png",               \
\
\ ; Checkbox colors
\
              clCheckboxBack,     HEX, <$ffffffff, $ffffffff, $ffffffff, $ffc0c0c0>,         \
              clCheckboxTxt,      HEX, $ff000000,                                            \
              clCheckboxTxtGray,  HEX, $ff808080,                                            \
              cbIconSize,         NUM, 13,                                                   \
              cbMargin,           NUM, 2,                                                    \
              borderCheckbox,     NUM, bxSunken,                                             \
              iconChecked,        PNG, "%lib%/gui/images/checkbox/check.png",                \
              iconCheckedGray,    PNG, "%lib%/gui/images/checkbox/check_gray.png",           \
\
\ ; TabBar control
\
              maxTabWidth,        NUM, 180,                                                  \
              tabMarginX,         NUM, 4,                                                    \
              tabMarginY,         NUM, 4,                                                    \
              clTabBk,            HEX, <$ffd4d0c8, $ffe0e0e0, $ffe0e0e0>,                    \
              clTabTxt,           HEX, $ff000000,                                            \
\
\ ; Grid control
              clGridCellBk,       HEX, <$ffffffff, $ffd4d0c8, $ff82C8FC, $ff0a246c>,         \  ; <regular, fixed, selected, focused> background color.
              clGridCellTxt,      HEX, <$ff000000, $ff000000, $ff000000, $ffffffff>,         \  ; <regular, fixed, selected, focused> text color.
              clGridLines,        HEX, <$00000000, $ffd4d0c8, $ffffffff, $ff000000>,         \  ;top-left data, bottom-right data, top-left fixed, bottom-right fixed.
\
\ ; ListView control
              lvIconMargin,       NUM, 3,                                                    \
\
\ ; Dialogs images
\
              iconDialogs,        PNG, <"%lib%/gui/themes/images/msgbox/error.png", "%lib%/gui/themes/images/msgbox/information.png", "%lib%/gui/themes/images/msgbox/question.png", "%lib%/gui/themes/images/msgbox/warning.png">, \
              iconDirectory,      PNG, <"%lib%/gui/themes/images/files/dir_light.png", "%lib%/gui/themes/images/files/dir_link_light.png">,                                                                                         \
              iconFile,           PNG, <"%lib%/gui/themes/images/files/file_light.png", "%lib%/gui/themes/images/files/file_link_light.png">,                                                                                       \
\
\ ; Default font
\
              DefaultFont,        FONT, "Liberation Sans":13:fwNormal:0

endg



endmodule