; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: libXrender import library.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto 'libXrender.so.1',                                                                                                                             \
        XRenderAddGlyphs,                <.display, .glyphset, .gids, .glyphs, .nglyphs, .images, .nbyte_images>,                               'XRenderAddGlyphs',                                                                 \
        XRenderAddTraps,                 <.display, .picture, .xOff, .yOff, .pTraps, .nTraps>,                                                  'XRenderAddTraps',
        XRenderChangePicture,            <.display, .picture, .valuemask, .attributes>,                                                         'XRenderChangePicture',                                                             \
        XRenderComposite,                <.display, .op, .src, .mask, .dst, .src_x, .src_y, .mask_x, .mask_y, .dst_x, .dst_y, .wodth, .height>, 'XRenderComposite',                                                                 \
        XRenderCompositeDoublePoly,      <.display, .op, .src, .dst, .maskFormat, .xSrc, .ySrc, .xDst, .yDst, .fpoints, .npoints, .winding>,    'XRenderCompositeDoublePoly',                                                       \
        XRenderCompositeString16,        <.display, .op, .src, .dst, .maskFormat, .glyphset, .xSrc, .ySrc, .xDst, .yDst, .string, .nchar>,      'XRenderCompositeString16',                                                         \
        XRenderCompositeString32,        <.display, .op, .src, .dst, .maskFormat, .glyphset, .xSrc, .ySrc, .xDst, .yDst, .string, .nchar>,      'XRenderCompositeString32',                                                         \
        XRenderCompositeString8,         <.display, .op, .src, .dst, .maskFormat, .glyphset, .xSrc, .ySrc, .xDst, .yDst, .string, .nchar>,      'XRenderCompositeString8',                                                          \
        XRenderCompositeText16,          <.display, .op, .src, .dst, .maskFormat, .glyphset, .xSrc, .ySrc, .xDst, .yDst, .elts, .nelt>,         'XRenderCompositeText16',                                                           \
        XRenderCompositeText32,          <.display, .op, .src, .dst, .maskFormat, .glyphset, .xSrc, .ySrc, .xDst, .yDst, .elts, .nelt>,         'XRenderCompositeText32',                                                           \
        XRenderCompositeText8,           <.display, .op, .src, .dst, .maskFormat, .glyphset, .xSrc, .ySrc, .xDst, .yDst, .elts, .nelt>,         'XRenderCompositeText8',                                                            \
        XRenderCompositeTrapezoids,      <.display, .op, .src, .dsp, .maskFormat, .xSrc, .ySrc, .traps, .ntrap>,                                'XRenderCompositeTrapezoids',                                                       \
        XRenderCompositeTriFan,          <.display, .op, .src, .dsp, .maskFormat, .xSrc, .ySrc, .points, .npoint>,                              'XRenderCompositeTriFan',                                                           \
        XRenderCompositeTriStrip,        <.display, .op, .src, .dsp, .maskFormat, .xSrc, .ySrc, .points, .npoint>,                              'XRenderCompositeTriStrip',                                                         \
        XRenderCompositeTriangles,       <.display, .op, .src, .dsp, .maskFormat, .xSrc, .ySrc, .triangles, .ntriangles>,                       'XRenderCompositeTriangles',                                                        \
        XRenderCreateAnimCursor,         <.display, .ncursor, .cursors>,                                                                        'XRenderCreateAnimCursor',                                                          \
        XRenderCreateConicalGradient,    <.display, .pGradient, .pStops, .pColors, .nStops>,                                                    'XRenderCreateConicalGradient',                                                     \
        XRenderCreateCursor,             <.display, .source, .x, .y>,                                                                           'XRenderCreateCursor',                                                              \
        XRenderCreateGlyphSet,           <.display, .format>,                                                                                   'XRenderCreateGlyphSet',                                                            \
        XRenderCreateLinearGradient,     <.display, .pGradient, .pStops, .pColors, .nStops>,                                                    'XRenderCreateLinearGradient',                                                      \
        XRenderCreatePicture,            <.display, .Drawable, .format, .valuemask, .attributes>,                                               'XRenderCreatePicture',                                                             \
        XRenderCreateRadialGradient,     <.display, .pGradient, .pStops, .pColors, .nStops>,                                                    'XRenderCreateRadialGradient',                                                      \
        XRenderCreateSolidFill,          <.display, .pColor>,                                                                                   'XRenderCreateSolidFill',                                                           \
        XRenderFillRectangle,            <.display, .op, .dst, .pColor, .x, .y, .width, .height>,                                               'XRenderFillRectangle',                                                             \
        XRenderFillRectangles,           <.display, .op, .dst, .pColor, .pRectangles, .nRectangles>,                                            'XRenderFillRectangles',                                                            \
        XRenderFindDisplay,              <NONE>,                                                                                                'XRenderFindDisplay',                                                               \
        XRenderFindFormat,               <.display, .mask, .templ, .count>,                                                                     'XRenderFindFormat',                                                                \
        XRenderFindStandardFormat,       <.display, .format>,                                                                                   'XRenderFindStandardFormat',                                                        \
        XRenderFindVisualFormat,         <.display, .visual>,                                                                                   'XRenderFindVisualFormat',                                                          \
        XRenderFreeGlyphSet,             <.display, .glyphset>,                                                                                 'XRenderFreeGlyphSet',                                                              \
        XRenderFreeGlyphs,               <.display, .glyphset, .pGids, .nGlyphs>,                                                               'XRenderFreeGlyphs',                                                                \
        XRenderFreePicture,              <.display, .picture>,                                                                                  'XRenderFreePicture',                                                               \
        XRenderParseColor,               <.display, .spec, .def>,                                                                               'XRenderParseColor',                                                                \
        XRenderQueryExtension,           <.display, .event_basep, .error_basep>,                                                                'XRenderQueryExtension',                                                            \
        XRenderQueryFilters,             <.display, .drawable>,                                                                                 'XRenderQueryFilters',                                                              \
        XRenderQueryFormats,             <.display>,                                                                                            'XRenderQueryFormats',                                                              \
        XRenderQueryPictIndexValues,     <.display, .format, .num>,                                                                             'XRenderQueryPictIndexValues',                                                      \
        XRenderQuerySubpixelOrder,       <.display, .screen>,                                                                                   'XRenderQuerySubpixelOrder',                                                        \
        XRenderQueryVersion,             <.display, .major_versionp, .minor_versionp>,                                                          'XRenderQueryVersion',                                                              \
        XRenderReferenceGlyphSet,        <.display, .existing>,                                                                                 'XRenderReferenceGlyphSet',                                                         \
        XRenderSetPictureClipRectangles, <.display, .picture, .xOrigin, .yOrigin, .rects, .n>,                                                  'XRenderSetPictureClipRectangles',                                                  \
        XRenderSetPictureClipRegion,     <.display, .picture, .region>,                                                                         'XRenderSetPictureClipRegion',                                                      \
        XRenderSetPictureFilter,         <.display, .picture, .pFilter, .pParams, .nParams>,                                                    'XRenderSetPictureFilter',                                                          \
        XRenderSetPictureTransform,      <.display, .picture, .pTransform>,                                                                     'XRenderSetPictureTransform',                                                       \
        XRenderSetSubpixelOrder,         <.display, .screen, .subpixel>,                                                                        'XRenderSetSubpixelOrder'


