; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: LibC import library.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes: Include only small amount of exported functions.
;_________________________________________________________________________________________

import_proto 'libc.so.6',                                                               \ ; LibC
  puts                                    ,<NONE>,                      'puts',         \
  exit                                    ,<.exit_code>,                'exit',         \
  malloc                                  ,<.size>,                     'malloc',       \
  free                                    ,<.ptr>,                      'free',         \
  realloc                                 ,<.ptr, .newsize>,            'realloc',      \
  stime                                   ,<NONE>,                      'stime',        \
  strerror_r                              ,<.errnum, .pBuff, .BufLen>,  'strerror_r',   \
  shmget                                  ,<.key, .size, .flags>,       'shmget',       \
  shmat                                   ,<.shmid, .addr, .flags>,     'shmat',        \
  shmdt                                   ,<.addr>,                     'shmdt',        \
  shmctl                                  ,<.shmid, .cmd, .shmid_ds>,   'shmctl',       \
  getaddrinfo                             ,<.pHostName, .pService, .pHints, .pVarResult>, 'getaddrinfo',        \
  freeaddrinfo                            ,<.pAddrInfo>,                                  'freeaddrinfo',       \
  crypt                                   ,<.pKey, .pSalt>,             'crypt'
