; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: SDL v1.2.11 API functions.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;
; SDL 1.2.11 includes written by Raedwulf
; a.k.a. Tai Chi Minh Ralph Eastwood
;
; There's no warranty for the correctness nor completeness of this file
; However, please mail me at tcmreastwood@ntlworld.com if you spot
; any errors in here.
;
; Version Date: 07/11/2006 (dd/mm/yyyy)
;_________________________________________________________________________________________

import_proto 'libSDL-1.2.so.0',                         \
    SDL_AddTimer, <NONE>, 'SDL_AddTimer',               \
    SDL_AllocRW, <NONE>, 'SDL_AllocRW',                 \
    SDL_AudioDriverName, <NONE>, 'SDL_AudioDriverName', \
    SDL_AudioInit, <NONE>, 'SDL_AudioInit',             \
    SDL_AudioQuit, <NONE>, 'SDL_AudioQuit',             \
    SDL_BuildAudioCVT, <NONE>, 'SDL_BuildAudioCVT',     \
    SDL_CDClose, <NONE>, 'SDL_CDClose',                 \
    SDL_CDEject, <NONE>, 'SDL_CDEject',                 \
    SDL_CDName, <NONE>, 'SDL_CDName',                   \
    SDL_CDNumDrives, <NONE>, 'SDL_CDNumDrives',         \
    SDL_CDOpen, <NONE>, 'SDL_CDOpen',                   \
    SDL_CDPause, <NONE>, 'SDL_CDPause',                 \
    SDL_CDPlay, <NONE>, 'SDL_CDPlay',                   \
    SDL_CDPlayTracks, <NONE>, 'SDL_CDPlayTracks',\
    SDL_CDResume, <NONE>, 'SDL_CDResume',\
    SDL_CDStatus, <NONE>, 'SDL_CDStatus',\
    SDL_CDStop, <NONE>, 'SDL_CDStop',\
    SDL_ClearError, <NONE>, 'SDL_ClearError',\
    SDL_CloseAudio, <NONE>, 'SDL_CloseAudio',\
    SDL_CondBroadcast, <NONE>, 'SDL_CondBroadcast',\
    SDL_CondSignal, <NONE>, 'SDL_CondSignal',\
    SDL_CondWait, <NONE>, 'SDL_CondWait',\
    SDL_CondWaitTimeout, <NONE>, 'SDL_CondWaitTimeout',\
    SDL_ConvertAudio, <NONE>, 'SDL_ConvertAudio',\
    SDL_ConvertSurface, <NONE>, 'SDL_ConvertSurface',\
    SDL_CreateCond, <NONE>, 'SDL_CreateCond',\
    SDL_CreateCursor, <NONE>, 'SDL_CreateCursor',\
    SDL_CreateMutex, <NONE>, 'SDL_CreateMutex',\
    SDL_CreateRGBSurface, <NONE>, 'SDL_CreateRGBSurface',\
    SDL_CreateRGBSurfaceFrom, <NONE>, 'SDL_CreateRGBSurfaceFrom',\
    SDL_CreateSemaphore, <NONE>, 'SDL_CreateSemaphore',\
    SDL_CreateThread, <NONE>, 'SDL_CreateThread',\
    SDL_CreateYUVOverlay, <NONE>, 'SDL_CreateYUVOverlay',\
    SDL_Delay, <NONE>, 'SDL_Delay',\
    SDL_DestroyCond, <NONE>, 'SDL_DestroyCond',\
    SDL_DestroyMutex, <NONE>, 'SDL_DestroyMutex',\
    SDL_DestroySemaphore, <NONE>, 'SDL_DestroySemaphore',\
    SDL_DisplayFormat, <NONE>, 'SDL_DisplayFormat',\
    SDL_DisplayFormatAlpha, <NONE>, 'SDL_DisplayFormatAlpha',\
    SDL_DisplayYUVOverlay, <NONE>, 'SDL_DisplayYUVOverlay',\
    SDL_EnableKeyRepeat, <NONE>, 'SDL_EnableKeyRepeat',\
    SDL_EnableUNICODE, <NONE>, 'SDL_EnableUNICODE',\
    SDL_Error, <NONE>, 'SDL_Error',\
    SDL_EventState, <NONE>, 'SDL_EventState',\
    SDL_FillRect, <NONE>, 'SDL_FillRect',\
    SDL_Flip, <NONE>, 'SDL_Flip',\
    SDL_FreeCursor, <NONE>, 'SDL_FreeCursor',\
    SDL_FreeRW, <NONE>, 'SDL_FreeRW',\
    SDL_FreeSurface, <NONE>, 'SDL_FreeSurface',\
    SDL_FreeWAV, <NONE>, 'SDL_FreeWAV',\
    SDL_FreeYUVOverlay, <NONE>, 'SDL_FreeYUVOverlay',\
    SDL_GL_GetAttribute, <NONE>, 'SDL_GL_GetAttribute',\
    SDL_GL_GetProcAddress, <NONE>, 'SDL_GL_GetProcAddress',\
    SDL_GL_LoadLibrary, <NONE>, 'SDL_GL_LoadLibrary',\
    SDL_GL_Lock, <NONE>, 'SDL_GL_Lock',\
    SDL_GL_SetAttribute, <NONE>, 'SDL_GL_SetAttribute',\
    SDL_GL_SwapBuffers, <NONE>, 'SDL_GL_SwapBuffers',\
    SDL_GL_Unlock, <NONE>, 'SDL_GL_Unlock',\
    SDL_GL_UpdateRects, <NONE>, 'SDL_GL_UpdateRects',\
    SDL_GetAppState, <NONE>, 'SDL_GetAppState',\
    SDL_GetAudioStatus, <NONE>, 'SDL_GetAudioStatus',\
    SDL_GetClipRect, <NONE>, 'SDL_GetClipRect',\
    SDL_GetCursor, <NONE>, 'SDL_GetCursor',\
    SDL_GetError, <NONE>, 'SDL_GetError',\
    SDL_GetEventFilter, <NONE>, 'SDL_GetEventFilter',\
    SDL_GetGammaRamp, <NONE>, 'SDL_GetGammaRamp',\
    SDL_GetKeyName, <NONE>, 'SDL_GetKeyName',\
    SDL_GetKeyRepeat, <NONE>, 'SDL_GetKeyRepeat',\
    SDL_GetKeyState, <NONE>, 'SDL_GetKeyState',\
    SDL_GetModState, <NONE>, 'SDL_GetModState',\
    SDL_GetMouseState, <NONE>, 'SDL_GetMouseState',\
    SDL_GetRGB, <NONE>, 'SDL_GetRGB',\
    SDL_GetRGBA, <NONE>, 'SDL_GetRGBA',\
    SDL_GetRelativeMouseState, <NONE>, 'SDL_GetRelativeMouseState',\
    SDL_GetThreadID, <NONE>, 'SDL_GetThreadID',\
    SDL_GetTicks, <NONE>, 'SDL_GetTicks',\
    SDL_GetVideoInfo, <NONE>, 'SDL_GetVideoInfo',\
    SDL_GetVideoSurface, <NONE>, 'SDL_GetVideoSurface',\
    SDL_GetWMInfo, <NONE>, 'SDL_GetWMInfo',\
    SDL_Has3DNow, <NONE>, 'SDL_Has3DNow',\
    SDL_Has3DNowExt, <NONE>, 'SDL_Has3DNowExt',\
    SDL_HasAltiVec, <NONE>, 'SDL_HasAltiVec',\
    SDL_HasMMX, <NONE>, 'SDL_HasMMX',\
    SDL_HasMMXExt, <NONE>, 'SDL_HasMMXExt',\
    SDL_HasRDTSC, <NONE>, 'SDL_HasRDTSC',\
    SDL_HasSSE, <NONE>, 'SDL_HasSSE',\
    SDL_HasSSE2, <NONE>, 'SDL_HasSSE2',\
    SDL_Init, <NONE>, 'SDL_Init',\
    SDL_InitSubSystem, <NONE>, 'SDL_InitSubSystem',\
    SDL_JoystickClose, <NONE>, 'SDL_JoystickClose',\
    SDL_JoystickEventState, <NONE>, 'SDL_JoystickEventState',\
    SDL_JoystickGetAxis, <NONE>, 'SDL_JoystickGetAxis',\
    SDL_JoystickGetBall, <NONE>, 'SDL_JoystickGetBall',\
    SDL_JoystickGetButton, <NONE>, 'SDL_JoystickGetButton',\
    SDL_JoystickGetHat, <NONE>, 'SDL_JoystickGetHat',\
    SDL_JoystickIndex, <NONE>, 'SDL_JoystickIndex',\
    SDL_JoystickName, <NONE>, 'SDL_JoystickName',\
    SDL_JoystickNumAxes, <NONE>, 'SDL_JoystickNumAxes',\
    SDL_JoystickNumBalls, <NONE>, 'SDL_JoystickNumBalls',\
    SDL_JoystickNumButtons, <NONE>, 'SDL_JoystickNumButtons',\
    SDL_JoystickNumHats, <NONE>, 'SDL_JoystickNumHats',\
    SDL_JoystickOpen, <NONE>, 'SDL_JoystickOpen',\
    SDL_JoystickOpened, <NONE>, 'SDL_JoystickOpened',\
    SDL_JoystickUpdate, <NONE>, 'SDL_JoystickUpdate',\
    SDL_KillThread, <NONE>, 'SDL_KillThread',\
    SDL_Linked_Version, <NONE>, 'SDL_Linked_Version',\
    SDL_ListModes, <NONE>, 'SDL_ListModes',\
    SDL_LoadBMP_RW, <NONE>, 'SDL_LoadBMP_RW',\
    SDL_LoadFunction, <NONE>, 'SDL_LoadFunction',\
    SDL_LoadObject, <NONE>, 'SDL_LoadObject',\
    SDL_LoadWAV_RW, <NONE>, 'SDL_LoadWAV_RW',\
    SDL_LockAudio, <NONE>, 'SDL_LockAudio',\
    SDL_LockSurface, <NONE>, 'SDL_LockSurface',\
    SDL_LockYUVOverlay, <NONE>, 'SDL_LockYUVOverlay',\
    SDL_LowerBlit, <NONE>, 'SDL_LowerBlit',\
    SDL_MapRGB, <NONE>, 'SDL_MapRGB',\
    SDL_MapRGBA, <NONE>, 'SDL_MapRGBA',\
    SDL_MixAudio, <NONE>, 'SDL_MixAudio',\
    SDL_NumJoysticks, <NONE>, 'SDL_NumJoysticks',\
    SDL_OpenAudio, <NONE>, 'SDL_OpenAudio',\
    SDL_PauseAudio, <NONE>, 'SDL_PauseAudio',\
    SDL_PeepEvents, <NONE>, 'SDL_PeepEvents',\
    SDL_PollEvent, <NONE>, 'SDL_PollEvent',\
    SDL_PumpEvents, <NONE>, 'SDL_PumpEvents',\
    SDL_PushEvent, <NONE>, 'SDL_PushEvent',\
    SDL_Quit, <NONE>, 'SDL_Quit',\
    SDL_QuitSubSystem, <NONE>, 'SDL_QuitSubSystem',\
    SDL_RWFromConstMem, <NONE>, 'SDL_RWFromConstMem',\
    SDL_RWFromFP, <NONE>, 'SDL_RWFromFP',\
    SDL_RWFromFile, <NONE>, 'SDL_RWFromFile',\
    SDL_RWFromMem, <NONE>, 'SDL_RWFromMem',\
    SDL_ReadBE16, <NONE>, 'SDL_ReadBE16',\
    SDL_ReadBE32, <NONE>, 'SDL_ReadBE32',\
    SDL_ReadBE64, <NONE>, 'SDL_ReadBE64',\
    SDL_ReadLE16, <NONE>, 'SDL_ReadLE16',\
    SDL_ReadLE32, <NONE>, 'SDL_ReadLE32',\
    SDL_ReadLE64, <NONE>, 'SDL_ReadLE64',\
    SDL_RegisterApp, <NONE>, 'SDL_RegisterApp',\
    SDL_RemoveTimer, <NONE>, 'SDL_RemoveTimer',\
    SDL_SaveBMP_RW, <NONE>, 'SDL_SaveBMP_RW',\
    SDL_SemPost, <NONE>, 'SDL_SemPost',\
    SDL_SemTryWait, <NONE>, 'SDL_SemTryWait',\
    SDL_SemValue, <NONE>, 'SDL_SemValue',\
    SDL_SemWait, <NONE>, 'SDL_SemWait',\
    SDL_SemWaitTimeout, <NONE>, 'SDL_SemWaitTimeout',\
    SDL_SetAlpha, <NONE>, 'SDL_SetAlpha',\
    SDL_SetClipRect, <NONE>, 'SDL_SetClipRect',\
    SDL_SetColorKey, <NONE>, 'SDL_SetColorKey',\
    SDL_SetColors, <NONE>, 'SDL_SetColors',\
    SDL_SetCursor, <NONE>, 'SDL_SetCursor',\
    SDL_SetError, <NONE>, 'SDL_SetError',\
    SDL_SetEventFilter, <NONE>, 'SDL_SetEventFilter',\
    SDL_SetGamma, <NONE>, 'SDL_SetGamma',\
    SDL_SetGammaRamp, <NONE>, 'SDL_SetGammaRamp',\
    SDL_SetModState, <NONE>, 'SDL_SetModState',\
    SDL_SetModuleHandle, <NONE>, 'SDL_SetModuleHandle',\
    SDL_SetPalette, <NONE>, 'SDL_SetPalette',\
    SDL_SetTimer, <NONE>, 'SDL_SetTimer',\
    SDL_SetVideoMode, <NONE>, 'SDL_SetVideoMode',\
    SDL_ShowCursor, <NONE>, 'SDL_ShowCursor',\
    SDL_SoftStretch, <NONE>, 'SDL_SoftStretch',\
    SDL_ThreadID, <NONE>, 'SDL_ThreadID',\
    SDL_UnloadObject, <NONE>, 'SDL_UnloadObject',\
    SDL_UnlockAudio, <NONE>, 'SDL_UnlockAudio',\
    SDL_UnlockSurface, <NONE>, 'SDL_UnlockSurface',\
    SDL_UnlockYUVOverlay, <NONE>, 'SDL_UnlockYUVOverlay',\
    SDL_UnregisterApp, <NONE>, 'SDL_UnregisterApp',\
    SDL_UpdateRect, <NONE>, 'SDL_UpdateRect',\
    SDL_UpdateRects, <NONE>, 'SDL_UpdateRects',\
    SDL_UpperBlit, <NONE>, 'SDL_UpperBlit',\
    SDL_VideoDriverName, <NONE>, 'SDL_VideoDriverName',\
    SDL_VideoInit, <NONE>, 'SDL_VideoInit',\
    SDL_VideoModeOK, <NONE>, 'SDL_VideoModeOK',\
    SDL_VideoQuit, <NONE>, 'SDL_VideoQuit',\
    SDL_WM_GetCaption, <NONE>, 'SDL_WM_GetCaption',\
    SDL_WM_GrabInput, <NONE>, 'SDL_WM_GrabInput',\
    SDL_WM_IconifyWindow, <NONE>, 'SDL_WM_IconifyWindow',\
    SDL_WM_SetCaption, <NONE>, 'SDL_WM_SetCaption',\
    SDL_WM_SetIcon, <NONE>, 'SDL_WM_SetIcon',\
    SDL_WM_ToggleFullScreen, <NONE>, 'SDL_WM_ToggleFullScreen',\
    SDL_WaitEvent, <NONE>, 'SDL_WaitEvent',\
    SDL_WaitThread, <NONE>, 'SDL_WaitThread',\
    SDL_WarpMouse, <NONE>, 'SDL_WarpMouse',\
    SDL_WasInit, <NONE>, 'SDL_WasInit',\
    SDL_WriteBE16, <NONE>, 'SDL_WriteBE16',\
    SDL_WriteBE32, <NONE>, 'SDL_WriteBE32',\
    SDL_WriteBE64, <NONE>, 'SDL_WriteBE64',\
    SDL_WriteLE16, <NONE>, 'SDL_WriteLE16',\
    SDL_WriteLE32, <NONE>, 'SDL_WriteLE32',\
    SDL_WriteLE64, <NONE>, 'SDL_WriteLE64',\
    SDL_getenv, <NONE>, 'SDL_getenv',\
    SDL_iconv, <NONE>, 'SDL_iconv',\
    SDL_iconv_close, <NONE>, 'SDL_iconv_close',\
    SDL_iconv_open, <NONE>, 'SDL_iconv_open',\
    SDL_iconv_string, <NONE>, 'SDL_iconv_string',\
    SDL_lltoa, <NONE>, 'SDL_lltoa',\
    SDL_mutexP, <NONE>, 'SDL_mutexP',\
    SDL_mutexV, <NONE>, 'SDL_mutexV',\
    SDL_putenv, <NONE>, 'SDL_putenv',\
    SDL_revcpy, <NONE>, 'SDL_revcpy',\
    SDL_snprintf, <NONE>, 'SDL_snprintf',\
    SDL_strdup, <NONE>, 'SDL_strdup',\
    SDL_strlcat, <NONE>, 'SDL_strlcat',\
    SDL_strlcpy, <NONE>, 'SDL_strlcpy',\
    SDL_strtoull, <NONE>, 'SDL_strtoull',\
    SDL_ulltoa, <NONE>, 'SDL_ulltoa',\
    SDL_vsnprintf, <NONE>, 'SDL_vsnprintf'

