; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: com32 (common object module) procedures.
;
;  Target OS: Win32
;
;  Dependencies:
;_________________________________________________________________________________________
uses ole32

; compares two GUID. Returns CF=1 if equal, CF=0 if not.

proc cmpGUID, .ptrGUID1, .ptrGUID2
begin
        push esi edi ecx

        mov     esi, [.ptrGUID1]
        mov     edi, [.ptrGUID2]
        mov     ecx, 4

        repe cmpsd
        clc
        jne  .finish
        stc
.finish:
        pop ecx edi esi
        return
endp


iglobal
 IID_IUnknown          GUID  00000000-0000-0000-C000-000000000046
 IID_IClassFactory     GUID  00000001-0000-0000-C000-000000000046
 IID_IOleObject        GUID  00000112-0000-0000-C000-000000000046
 IID_IOleInPlaceObject GUID  00000113-0000-0000-C000-000000000046
 IID_IOleInPlaceSite   GUID  00000119-0000-0000-C000-000000000046
 IID_IOleClientSite    GUID  00000118-0000-0000-C000-000000000046

 IID_IDocHostUIHandler GUID  BD3F23C0-D43E-11CF-893B-00AA00BDCE1A
 CLSID_WebBrowser      GUID  8856F961-340A-11D0-A96B-00C04FD705A2
 IID_IWebBrowser2      GUID  D30C1661-CDAF-11D0-8A3E-00C04FC9E26E
 IID_IHTMLDocument2    GUID  332C4425-26CB-11D0-B483-00C04FD90119
endg
