; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Process management library.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: Includes the proper OS dependent part of the library.
;_________________________________________________________________________________________
module "Process library"


interface Terminate, .exit_code

interface TerminateAll, .exit_code

interface SetForcedTerminateHandler, .procHandler

interface procForcedTerminateHandler, .reason

interface GetCmdArguments



interface ThreadCreate, .ptrFunction, .ptrArguments

interface FreeThreadID, .ThreadID


; Executes the command .hCommand, gets the STDIN from [.hStdIn] file handle,
; Outputs the STDOUT to [.hStdOut] file handle and STDERR to [.hStdErr] handle.

interface Exec2, .hCommand, .hStdIn, .hStdOut, .hStdErr

interface FreeProcessID, .ProcessID

interface WaitProcessExit, .ProcessID, .timeout



interface MutexCreate, .ptrName, .ptrMutex

interface WaitForMutex, .ptrMutex, .timeout

interface MutexRelease, .ptrMutex

interface MutexDestroy, .ptrMutex


; Simple wrapper on Exec2;
; See Exec2

proc Exec, .hCommand
begin
        stdcall Exec2, [.hCommand], [STDIN], [STDOUT], [STDERR]
        return
endp





include '%TargetOS%/process.asm'


if used ThreadCreate
  options.Threads = 1
else
  options.Threads = 0
end if

endmodule
