;<ff
Window frmMainOptions, 3, 0, 'TForm', 'IDE options', $24C0000, $10001, 0, 390, 178, 640, 480, IDEOptionsWinProc;
Window NONE, 0, 1, 'SysListView32', 'ListView', $5401E18D, $200, 1000, 8, 8, 192, 437, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $54010001, $0, 1, 480, 416, 64, 25, 0;
Window NONE, 2, 0, 'BUTTON', 'Cancel', $54010000, $0, 2, 552, 416, 64, 25, 0;
;ff>
;***********************************************************
; This file contains routines for reading/writing/handling
; parameters of Fresh IDE
;***********************************************************

; Special OM_ messages for options applet windows.
winmessage OM_SAVEOPTIONS
winmessage OM_LOADOPTIONS
winmessage OM_UPDATEDIALOG
;winmessage OM_THEMECHANGED


iglobal
  cTitleBtnEdit du '...', 0      ; common button text for TButtonEdit
  cOptionsApplets dd frmIDEOptions, frmExternalOptions, frmIDEBehaviour, frmEditorColors, frmUserSyntax, 0


  SplitStart IDEOptionsLayout
    Split stHoriz or stJustGap, 8, 160, 0, 1000
      Cell cellCategory
      Split stVert or stOriginBR or stJustGap, 8, 25, 0, 1000
        Cell cellPanel
        Split stHoriz or stOriginBR or stJustGap, 8, 64, 0, 1000
          Split stHoriz or stOriginBR or stJustGap, 8, 64, 0, 1000
            Cell cellEmpty
            Cell cellBtnOK
          Cell cellBtnCancel
  SplitEnd

endg

;---------------------------------------------------
; Opens IDE options dialog.
;---------------------------------------------------
proc OnIDEOptions, .wparam, .lparam
begin
        stdcall CreateForm, frmMainOptions, [hMainForm]
        stdcall ShowModal, ebx, MSF_CENTER
        invoke  DestroyWindow, ebx

        stdcall CheckParams
        invoke  PostMessageW, [hMainForm], WM_COMMAND, actReloadVCL, 0
        return
endp



;-----------------------------------------------------------------------
; Window procedure for the Options form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
proc IDEOptionsWinProc, .hwnd, .wmsg, .wparam, .lparam

  .lvi LVITEM

begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return



oncase SGM_REALIGN

        stdcall OnRealignWithPadding, [.hwnd], 8, 8, 8, 8

        clc
        return



oncase WM_COMMAND

        cmp     word [.wparam], MR_OK
        jne     .ondefault

        invoke  GetDlgItem, [.hwnd], 1000
        mov     ebx, eax
        lea     edi, [.lvi]

        invoke  SendMessageW, ebx, LVM_GETITEMCOUNT, 0, 0
        dec     eax
        mov     [edi+LVITEM.iItem], eax

        mov     [edi+LVITEM.mask], LVIF_PARAM
        mov     [edi+LVITEM.iSubItem], 0

.itemsave:
        invoke  SendMessageW, ebx, LVM_GETITEMW, 0, edi
        invoke  SendMessageW, [edi+LVITEM.lParam], OM_SAVEOPTIONS, 0, 0
        dec     [edi+LVITEM.iItem]
        jns     .itemsave

        jmp     .ondefault      ; in order to close the dialog.


oncase WM_NOTIFY

        cmp     [.wparam], 1000
        jne     .ondefault

        mov     esi, [.lparam]
        cmp     [esi+NMHDR.code], LVN_ITEMCHANGED
        jne     .ondefault

        test    [esi+NMLISTVIEW.uChanged], LVIF_STATE
        jz      .ondefault

        test    [esi+NMLISTVIEW.uNewState], LVIS_FOCUSED
        jz      .end_focus

        stdcall AttachToCell, [esi+NMLISTVIEW.lParam], [.hwnd], IDEOptionsLayout.cellPanel
        jc      .end_focus

        push    eax
        invoke  ShowWindow, [esi+NMLISTVIEW.lParam], SW_SHOWNORMAL
        pop     eax

        test    eax, eax
        jz      .end_focus

        cmp     eax, [esi+NMLISTVIEW.lParam]
        je      .end_focus

        invoke  ShowWindow, eax, SW_HIDE

.end_focus:
        clc
        return



oncase WM_DESTROY

        invoke  GetPropW, [.hwnd], [propTempSettings]
        stdcall DestroySettings, eax
        invoke  RemovePropW, [.hwnd], [propTempSettings]

        stc
        return


oncase FM_AFTERCREATE
locals
  .hlv dd ?
  .lvc LVCOLUMN
  .rect RECT
endl

        stdcall SetSplitGrid, [.hwnd], IDEOptionsLayout

        stdcall AttachToCellDlgItem, [.hwnd], 1000, IDEOptionsLayout.cellCategory
        stdcall AttachToCellDlgItem, [.hwnd], 1, IDEOptionsLayout.cellBtnOK
        stdcall AttachToCellDlgItem, [.hwnd], 2, IDEOptionsLayout.cellBtnCancel

; for the edit options.

        stdcall ThemeDuplicate, [CurrentSettings]
        invoke  SetPropW, [.hwnd], [propTempSettings], eax


        invoke  GetDlgItem, [.hwnd], 1000
        mov     [.hlv], eax

        mov     eax, [iTheme]
        stdcall ImageList_LoadPNG, [GUI.imgApplets + 8*eax], FALSE
        invoke  SendMessageW, [.hlv], LVM_SETIMAGELIST, LVSIL_SMALL, eax

;        lea     eax, [.rect]
;        invoke  GetClientRect, [.hlv], eax
;
;        add     [.rect.left], 8
;        add     [.rect.top], 8
;        sub     [.rect.right], 8
;        sub     [.rect.bottom], 8
;
;        lea     eax, [.rect]
;        invoke  SendMessageW, [.hlv], LVM_SETWORKAREA, 1, eax           ; does not works in WINE, but works in Windows

        mov     ecx, sizeof.LVCOLUMN/4
        lea     edi, [.lvc]
        xor     eax, eax
        rep stosd

        mov     [.lvc.mask], LVCF_FMT or LVCF_SUBITEM
        mov     [.lvc.fmt], LVCFMT_LEFT
        mov     [.lvc.iSubItem], 0

        lea     eax, [.lvc]
        invoke  SendMessageW, [.hlv], LVM_INSERTCOLUMNW, 0, eax

        xor     esi, esi
        lea     edi, [.lvi]

        mov     [edi+LVITEM.mask], LVIF_TEXT or LVIF_PARAM or LVIF_IMAGE
        mov     [edi+LVITEM.iSubItem], 0


.addloop:
        mov     ecx, [4*esi+cOptionsApplets]
        jecxz   .endadd

        stdcall CreateForm, ecx, [.hwnd]

        mov     [edi+LVITEM.lParam], ebx

        stdcall GetControlTextW, ebx
        push    eax

        mov     [edi+LVITEM.pszText], eax
        mov     [edi+LVITEM.iImage], esi
        mov     [edi+LVITEM.iItem], esi

        invoke  SendMessageW, [.hlv], LVM_INSERTITEMW, 0, edi

        stdcall FreeMem ; from the stack

        invoke  SendMessageW, ebx, OM_LOADOPTIONS, 0, 0

        inc     esi
        jmp     .addloop

.endadd:
        invoke  SendMessageW, [.hlv], LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_BORDERSELECT or LVS_EX_FULLROWSELECT
        invoke  SendMessageW, [.hlv], LVM_SETCOLUMNWIDTH, 0, LVSCW_AUTOSIZE_USEHEADER

        stdcall ListViewCenterIcons, [.hlv]

        mov     [.lvi.stateMask], TVIS_FOCUSED or TVIS_SELECTED
        mov     [.lvi.state], TVIS_FOCUSED or TVIS_SELECTED
        mov     [.lvi.iItem], 0
        lea     eax, [.lvi]
        invoke  SendMessageW, [.hlv], LVM_SETITEMSTATE, 0, eax

        clc
        return




        enddispatch
endp




proc ButtonEditFileSelect, .hFileName, .hButtonEdit
begin
        stdcall SetControlTextUtf8, [.hButtonEdit], [.hFileName]
        return
endp



proc ListViewCenterIcons, .hListView
.rect RECT
begin
        pushad

        lea     eax, [.rect]
        invoke  GetClientRect, [.hListView], eax

        invoke  SendMessageW, [.hListView], LVM_GETITEMCOUNT, 0, 0

        mov     ecx, eax
        mov     eax, [.rect.bottom]
        xor     edx, edx

        div     ecx
        shl     eax, 16

        or      eax, [.rect.right]

        invoke  SendMessageW, [.hListView], LVM_SETICONSPACING, 0, eax

        popad
        return
endp