;<ff
Window frmLabelInfo, 2, 0, 'TForm', 'Cross reference', $C0000, $10080, 0, 575, 138, 416, 240, LabelInfoWinProc;
;ff>
iglobal
  SplitStart XRefLayout
    Cell cellXRef
  SplitEnd

endg


proc LabelInfoWinProc, .hwnd, .wmsg, .wparam, .lparam
.lvi LVITEM
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return


oncase WM_COMMAND

        cmp     [.wparam], MR_OK
        je      .onenter

        cmp     [.wparam], MR_CANCEL
        jne     .ondefault

        invoke  PostMessageW, [.hwnd], WM_CLOSE, 0, 0
        jmp     .ondefault

.onenter:
        invoke  GetDlgItem, [.hwnd], idLabelProp
        invoke  GetDlgItem, eax, idXRefList
        mov     ebx, eax

        invoke  SendMessageW, ebx, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
        cmp     eax, -1
        je      .ondefault

        mov     [.lvi.iItem], eax

        stdcall GetMem, 2048    ; buffer for the filename
        mov     edi, eax

        mov     [.lvi.mask], LVIF_PARAM or LVIF_TEXT
        mov     [.lvi.iSubItem], 2        ; file name pointer
        mov     [.lvi.pszText], edi
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendMessageW, ebx, LVM_GETITEMW, 0, eax

        stdcall WideCharToUtf8, edi

        stdcall PosEditor, eax, [.lvi.lParam]
        stdcall StrDel, eax
        stdcall FreeMem, edi

        invoke  SetFocus, [.hwnd]
        clc
        return


oncase FM_AFTERCREATE

        stdcall SetSplitGrid, [.hwnd], XRefLayout

        stdcall CreateForm, frmLabelProp, [.hwnd]
        invoke  SetWindowLongW, ebx, GWL_ID, idLabelProp
        stdcall AttachToCell, ebx, [.hwnd], XRefLayout.cellXRef

        clc
        return


oncase WM_CLOSE

        invoke  DestroyWindow, [.hwnd]
        clc
        return

        enddispatch

endp







;-----------------------------------------------------------------------

uglobal
  hLabelInfo dd ?
endg


proc OnShowXRef, .wparam, .lparam
.aedit  dd ?
.aepos  AEPOS
.str    rw 512
.rect RECT
.oldcursor dd ?
begin
        stdcall WaitForCompiler
        jc      .missing_info

        mov     edi, [ptrPreprocessed]
        test    edi, edi
        jz      .missing_info

        stdcall GetCurrentAsmEdit
        jc      .finish

        mov     [.aedit], eax

        lea     esi, [.str]
        invoke  SendMessageW, eax, AEM_GETWORDATCARET, 512, esi
        cmp     word [esi], 0
        je      .finish

        stdcall WideCharToUtf8, esi
        mov     esi, eax

        stdcall StrPtr, esi
        cmp     byte [eax], '.'
        jne     .localok

        lea     eax, [.aepos]
        invoke  SendMessageW, [.aedit], AEM_GETPOS, eax, 0

        stdcall SearchForLabelPrefixInEditor, [.aedit], [.aepos.caretLine]
        test    eax, eax
        jz      .localok

        stdcall StrDup, eax             ; the returned string MUST NOT be deleted!
        stdcall StrCat, eax, esi
        stdcall StrDel, esi
        mov     esi, eax

; here esi contains a pointer to the whole name including the parent label.
.localok:
        stdcall SearchTreeExact, esi, ptrLabels
        test    eax, eax
        jz      .finish_free

;        test    [eax+TLabel.flags], lfDefined
;        jz      .finish

        stdcall StrDel, esi
        mov     esi, eax

        cmp     [hLabelInfo], 0
        je      .prevok

        invoke  DestroyWindow, [hLabelInfo]

.prevok:

        lea     eax, [.rect]
        invoke  GetWindowRect, [hEditorsHost], eax

        sub     [.rect.right], 440
        add     [.rect.top], 32

        stdcall CreateForm, frmLabelInfo, [hMainForm]
        mov     [hLabelInfo], ebx

        invoke  GetDlgItem, ebx, idLabelProp

        stdcall SetCellHidden, eax, LblLayout.cellLabelInfo, 0  ; preserves eax

        invoke  GetDlgItem, eax, 1
        invoke  ShowWindow, eax, SW_HIDE

        invoke  LoadCursorW, 0, IDC_WAIT
        invoke  SetCursor, eax
        mov     [.oldcursor], eax

        invoke  SendDlgItemMessageW, ebx, idLabelProp, LPR_DISPLAY, 0, esi

        invoke  SetCursor, [.oldcursor]

        invoke  SetWindowPos, ebx, 0, [.rect.right], [.rect.top], 0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_SHOWWINDOW or SWP_NOACTIVATE

        stdcall ProcessMessages

        invoke  SetFocus, [hEditorsHost]

.finish_free:

        stdcall StrDel, esi

.finish:
        return

.missing_info:
        stdcall ErrorMessage, errNotCompiled
        jmp     .finish
endp
