;<ff
Window frmBrowser, 3, 0, 'TForm', 'Labels explorer', $D0000, $10080, 0, 619, 141, 640, 480, frmBrowserWinProc;
Window NONE, 0, 5, 'SysTreeView32', 'TreeView', $50000037, $200, 901, 0, 40, 504, 411, 0;
Window NONE, 3, 3, 'BUTTON', 'Filter', $50000007, $20, 900, 0, 0, 632, 42, FiltersProc;
Window NONE, 0, 0, 'BUTTON', 'Structures', $50000009, $20, 101, 64, 16, 72, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Data', $50000009, $20, 102, 136, 16, 48, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Show all', $50000009, $20, 104, 256, 16, 64, 17, 0;
Window NONE, 0, 0, 'BUTTON', 'Labels', $50000009, $20, 100, 8, 16, 56, 17, 0;
Window NONE, 2, 0, 'BUTTON', 'Constants', $50000009, $20, 103, 184, 16, 72, 17, 0;
;ff>
cExplorerRoot text 'Root'

idFilters = 900
idLblTree = 901

idLabels     = 100
idStructures = 101
idData       = 102
idConst      = 103
idAll        = 104

uglobal
  hLabelExplorer dd ?
endg


iglobal
  SplitStart LblExplorerLayout
    Split stVert or stJustGap, 0, 42, 0, 1000
      Cell cellFilters
      Split stHoriz or stRelative, 4, 16384,  1024, 32768-1024
        Cell cellTree
        Cell cellXRef
  SplitEnd
endg


proc OnExplorer, .wparam, .lparam
.rect RECT
begin
        cmp     [hLabelExplorer], 0
        je      .oldwin_ok

        invoke  SendMessageW, [hLabelExplorer], WM_CLOSE, 0, 0
        mov     [hLabelExplorer], 0

.oldwin_ok:
        cmp     [ptrLabels], 0
        je      .missing_info

        lea     eax, [.rect]
        invoke  GetWindowRect, [hEditorsHost], eax

        sub     [.rect.right], 680
        add     [.rect.top], 32

        stdcall CreateForm, frmBrowser, [hEditorsHost]
        mov     [hLabelExplorer], ebx

        invoke  SetWindowPos, ebx, 0, [.rect.right], [.rect.top], 0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_SHOWWINDOW

.finish:
        return

.missing_info:
        stdcall ErrorMessage, errNotCompiled
        jmp     .finish
endp


proc __CheckLabelUsed, .ptrLabel
begin
        push    esi ecx

        mov     esi, [.ptrLabel]

        test    [esi+TLabel.flags], lfUsed
        jnz     .finish_used

        mov     esi, [esi+TLabel.Children]
        test    esi, esi
        jz      .finish_not_used

        mov     ecx, [esi+TArray.count]
        lea     esi, [esi+TArray.array]

.loop:
        dec     ecx
        js      .finish_not_used

        stdcall __CheckLabelUsed, esi
        lea     esi, [esi+sizeof.TLabel]
        jnc      .loop

.finish_used:
        stc
        pop     ecx esi
        return

.finish_not_used:
        clc
        pop     ecx esi
        return
endp




proc AddLabelsToTree, .tree, .parent, .ptrVarArray, .filterProc
.tvi  TVINSERTSTRUCT
begin
        push    esi ebx

        mov     eax, [.ptrVarArray]
        mov     esi, [eax]              ; pointer to TArray
        test    esi, esi
        jz      .finish

        mov     ebx, [esi+TArray.count]
        lea     esi, [esi+TArray.array]

.iteratelist:
;        cmp     [esi+TLabel.Children], 0        ; because some of the childrens
;        jne     .addit

        test    [esi+TLabel.flags], lfDefined
        jz      .next

        stdcall __CheckLabelUsed, esi
        jnc     .next

        cmp     [.filterProc], 0
        je      .addit

        call    [.filterProc]
        jnc     .next

.addit:
        mov     eax, [.parent]
        mov     [.tvi.hParent], eax
        mov     ecx, TVI_LAST
        cmp     eax, TVI_ROOT
        jne     @f
        mov     ecx, TVI_SORT
@@:
        mov     [.tvi.hInsertAfter], ecx
        mov     [.tvi.item.mask], TVIF_TEXT or TVIF_PARAM

        mov     eax, [esi+TLabel.iName]
        add     eax, [ptrNames]

        stdcall utf8ToWideChar, eax
        push    eax

        mov     [.tvi.item.pszText], eax
        mov     [.tvi.item.lParam], esi

        lea     eax, [.tvi]
        invoke  SendMessageW, [.tree], TVM_INSERTITEMW, 0, eax
        stdcall FreeMem ; from the stack

        cmp     [esi+TLabel.Children], 0
        je      .next

        stdcall AddLabelsToTree, [.tree], eax, esi, 0

.next:
        add     esi, sizeof.TLabel
        dec     ebx
        jnz     .iteratelist

.finish:
        pop     ebx esi
        return
endp




;**************************************************************************
; frmBrowser message handling procedure.
;
;   hwnd - handle of the form window
;   wmsg     - message code
;   wparam, lparam - parameters of the message
;**************************************************************************
proc frmBrowserWinProc, .hwnd, .wmsg, .wparam, .lparam
begin
        mov     ebx, [.wmsg]
        call    JumpTo
        MessageList                                             \
        FM_AFTERCREATE, .fmaftercreate,                         \
        WM_NOTIFY,      .wmnotify,                              \
        WM_CLOSE,       .wmclose

.default:
        stc
        return

.wmclose:
        invoke  DestroyWindow, [.hwnd]
        clc
        return

.fmaftercreate:
        stdcall SetSplitGrid, [.hwnd], LblExplorerLayout

        stdcall CreateForm, frmLabelProp, [.hwnd]
        invoke  SetWindowLongW, ebx, GWL_ID, idLabelProp

        stdcall AttachToCellDlgItem, [.hwnd], idFilters, LblExplorerLayout.cellFilters
        stdcall AttachToCellDlgItem, [.hwnd], idLblTree, LblExplorerLayout.cellTree
        stdcall AttachToCellDlgItem, [.hwnd], idLabelProp, LblExplorerLayout.cellXRef

        invoke  GetDlgItem, [.hwnd], idFilters
        mov     ebx, eax

        invoke  SendDlgItemMessageW, ebx, idLabels, BM_SETCHECK, 1, 0
        invoke  SendMessageW, ebx, WM_COMMAND, idLabels, 0

        invoke  SetFocus, ebx

        clc
        return

.wmnotify:
        mov     esi, [.lparam]
        cmp     [esi+NMHDR.code], TVN_SELCHANGEDW
        je      .selchanged

        jmp     .default

; selection of the treeview changed.
.selchanged:
; Pointer to TLabel structure of given label.
;        invoke  GetDlgItem, [.hwnd], 1
;        mov     ebx, eax

        mov     edi, [esi+NMTREEVIEW.itemNew.lParam]
        test    edi, edi
        jz      .finish

        invoke  SendDlgItemMessageW, [.hwnd], idLabelProp, LPR_DISPLAY, 0, edi

.finish:
        clc
        return
endp






proc FiltersProc, .hwnd, .wmsg, .wparam, .lparam
begin
        cmp     [.wmsg], WM_COMMAND
        je      .wmcommand
.default:
        stc
        return

.wmcommand:
        movzx   eax, word [.wparam]
        cmp     eax, idLabels
        jl      .default
        cmp     eax, idAll
        jg      .default

.update:
; Update tree-view control
        push    eax

        invoke  GetParent, [.hwnd]
        invoke  GetDlgItem, eax, idLblTree
        mov     edi, eax
        invoke  LockWindowUpdate, edi
        invoke  SendMessageW, edi, TVM_DELETEITEM, 0, TVI_ROOT

        pop     eax

        mov     edx, procCheckForLabel
        cmp     eax, idLabels
        je      .filterok

        mov     edx, procCheckForStruct
        cmp     eax, idStructures
        je      .filterok

        mov     edx, procCheckForData
        cmp     eax, idData
        je      .filterok

        mov     edx, procCheckForConst
        cmp     eax, idConst
        je      .filterok

        xor     edx, edx

.filterok:
        stdcall AddLabelsToTree, edi, TVI_ROOT, ptrLabels, edx
        invoke  LockWindowUpdate, NULL
        clc
        return
endp





;------------------------------------------------
; FILTER PROCEDURES
;------------------------------------------------

proc procCheckForLabel
begin
        test    [esi+TLabel.flags], lfCanRedefine
        jnz     .no

        test    [esi+TLabel.flags], lfOptimized
        jz      .no

        cmp     [esi+TLabel.DataSize], 0
        jne     .no

        stc
        return
.no:    clc
        return
endp


proc procCheckForStruct
begin
        cmp     [esi+TLabel.ValueLo], 0
        jne     .no
        cmp     [esi+TLabel.ValueHi], 0
        jne     .no

        test    [esi+TLabel.flags], lfOptimized
        jnz      .no

        test    [esi+TLabel.flags], lfDefined
        jz      .no

        test    [esi+TLabel.flags], lfCanRedefine
        jnz     .no

        cmp     [esi+TLabel.DataSize], 0
        jne     .no

        stc
        return
.no:    clc
        return
endp



proc procCheckForData
begin
        cmp     [esi+TLabel.DataSize], 0
        je      .no
        stc
        return

.no:    clc
        return
endp



proc procCheckForConst
begin
        test    [esi+TLabel.flags], lfCanRedefine
        jz      .no
        stc
        return
.no:    clc
        return
endp



