struc EncodingArray [number, shtxt, longtxt] {
forward
  local txt1, txt2
        dd  number, txt1, txt2
common
        dd  0
forward
txt1 du shtxt, 0
txt2 du longtxt, 0
}



cAllEncodings EncodingArray                                                                                                                     \
        37,     "IBM-037",           "IBM EBCDIC US-Canada",                                                                                    \
        437,    "IBM-437",           "OEM United States",                                                                                       \
        500,    "IBM-500",           "IBM EBCDIC International",                                                                                \
        708,    "ASMO-708",          "Arabic (ASMO 708)",                                                                                       \
        709,    "ASMO-449+",         "Arabic (ASMO-449+, BCON V4)",                                                                             \
        710,    "CP-710",            "Arabic - Transparent Arabic",                                                                             \
        720,    "DOS-720",           "Arabic (Transparent ASMO)",                                                                               \
        737,    "IBM-737",           "OEM Greek (formerly 437G)",                                                                               \
        775,    "IBM-775",           "OEM Baltic",                                                                                              \
        850,    "IBM-850",           "OEM Multilingual Latin 1",                                                                                \
        852,    "IBM-852",           "OEM Latin 2",                                                                                             \
        855,    "IBM-855",           "OEM Cyrillic (primarily Russian)",                                                                        \
        857,    "IBM-857",           "OEM Turkish",                                                                                             \
        858,    "IBM-858",           "OEM Multilingual Latin 1 + Euro symbol",                                                                  \
        860,    "IBM-860",           "OEM Portuguese",                                                                                          \
        861,    "IBM-861",           "OEM Icelandic",                                                                                           \
        862,    "DOS-862",           "OEM Hebrew",                                                                                              \
        863,    "IBM-863",           "OEM French Canadian",                                                                                     \
        864,    "IBM-864",           "OEM Arabic",                                                                                              \
        865,    "IBM-865",           "OEM Nordic",                                                                                              \
        866,    "CP-866",            "OEM Russian",                                                                                             \
        869,    "IBM-869",           "OEM Modern Greek",                                                                                        \
        870,    "IBM-870",           "IBM EBCDIC Multilingual/ROECE (Latin 2)",                                                                 \
        874,    "WIN-874",           "ANSI/OEM Thai (ISO 8859-11)",                                                                             \
        875,    "CP-875",            "IBM EBCDIC Greek Modern",                                                                                 \
        932,    "SHIFT_JIS",         "ANSI/OEM Japanese",                                                                                       \
        936,    "GB-2312",           "ANSI/OEM Simplified Chinese (PRC, Singapore)",                                                            \
        949,    "KS_C_5601-1987",    "ANSI/OEM Korean (Unified Hangul Code)",                                                                   \
        950,    "BIG5",              "ANSI/OEM Traditional Chinese (Taiwan, Hong Kong SAR, PRC)",                                               \
        1026,   "IBM-1026",          "IBM EBCDIC Turkish (Latin 5)",                                                                            \
        1047,   "IBM-1047",          "IBM EBCDIC Latin 1/Open System",                                                                          \
        1140,   "IBM-1140",          "IBM EBCDIC US-Canada (037 + Euro symbol)",                                                                \
        1141,   "IBM-1141",          "IBM EBCDIC Germany (20273 + Euro symbol)",                                                                \
        1142,   "IBM-1142",          "IBM EBCDIC Denmark-Norway (20277 + Euro symbol)",                                                         \
        1143,   "IBM-1143",          "IBM EBCDIC Finland-Sweden (20278 + Euro symbol)",                                                         \
        1144,   "IBM-1144",          "IBM EBCDIC Italy (20280 + Euro symbol)",                                                                  \
        1145,   "IBM-1145",          "IBM EBCDIC Latin America-Spain (20284 + Euro symbol)",                                                    \
        1146,   "IBM-1146",          "IBM EBCDIC United Kingdom (20285 + Euro symbol)",                                                         \
        1147,   "IBM-1147",          "IBM EBCDIC France (20297 + Euro symbol)",                                                                 \
        1148,   "IBM-1148",          "IBM EBCDIC International (500 + Euro symbol)",                                                            \
        1149,   "IBM-1149",          "IBM EBCDIC Icelandic (20871 + Euro symbol)",                                                              \
        1200,   "UTF-16LE",          "Unicode UTF-16, little endian byte order",                                                                \
        1201,   "UTF-16BE",          "Unicode UTF-16, big endian byte order",                                                                   \
        1250,   "WIN-1250",          "ANSI Central European",                                                                                   \
        1251,   "WIN-1251",          "ANSI Cyrillic",                                                                                           \
        1252,   "WIN-1252",          "ANSI Latin 1",                                                                                            \
        1253,   "WIN-1253",          "ANSI Greek",                                                                                              \
        1254,   "WIN-1254",          "ANSI Turkish",                                                                                            \
        1255,   "WIN-1255",          "ANSI Hebrew",                                                                                             \
        1256,   "WIN-1256",          "ANSI Arabic",                                                                                             \
        1257,   "WIN-1257",          "ANSI Baltic",                                                                                             \
        1258,   "WIN-1258",          "ANSI/OEM Vietnamese",                                                                                     \
        1361,   "Johab",             "Korean (Johab)",                                                                                          \
        10000,  "MACINTOSH",         "MAC Roman",                                                                                               \
        10001,  "X-MAC-japanese",    "Japanese (Mac)",                                                                                          \
        10002,  "X-MAC-chinesetrad", "MAC Traditional Chinese (Big5)",                                                                          \
        10003,  "X-MAC-korean",      "Korean (Mac)",                                                                                            \
        10004,  "X-MAC-arabic",      "Arabic (Mac)",                                                                                            \
        10005,  "X-MAC-hebrew",      "Hebrew (Mac)",                                                                                            \
        10006,  "X-MAC-greek",       "Greek (Mac)",                                                                                             \
        10007,  "X-MAC-cyrillic",    "Cyrillic (Mac)",                                                                                          \
        10008,  "X-MAC-chinesesimp", "MAC Simplified Chinese (GB 2312)",                                                                        \
        10010,  "X-MAC-romanian",    "Romanian (Mac)",                                                                                          \
        10017,  "X-MAC-ukrainian",   "Ukrainian (Mac)",                                                                                         \
        10021,  "X-MAC-thai",        "Thai (Mac)",                                                                                              \
        10029,  "X-MAC-ce",          "MAC Latin 2",                                                                                             \
        10079,  "X-MAC-icelandic",   "Icelandic (Mac)",                                                                                         \
        10081,  "X-MAC-turkish",     "Turkish (Mac)",                                                                                           \
        10082,  "X-MAC-croatian",    "Croatian (Mac)",                                                                                          \
        12000,  "UTF-32",            "Unicode UTF-32, little endian byte order",                                                                \
        12001,  "UTF-32BE",          "Unicode UTF-32, big endian byte order",                                                                   \
        20000,  "X-Chinese_CNS",     "CNS Taiwan",                                                                                              \
        20001,  "X-CP-20001",         "TCA Taiwan",                                                                                             \
        20002,  "X_Chinese-Eten",    "Eten Taiwan",                                                                                             \
        20003,  "X-CP-20003",         "IBM-5550 Taiwan",                                                                                        \
        20004,  "X-CP-20004",         "TeleText Taiwan",                                                                                        \
        20005,  "X-CP-20005",         "Wang Taiwan",                                                                                            \
        20105,  "X-IA5",             "IA5 (IRV International Alphabet No. 5, 7-bit)",                                                           \
        20106,  "X-IA5-German",      "IA5 German (7-bit)",                                                                                      \
        20107,  "X-IA5-Swedish",     "IA5 Swedish (7-bit)",                                                                                     \
        20108,  "X-IA5-Norwegian",   "IA5 Norwegian (7-bit)",                                                                                   \
        20127,  "US-ASCII",          "US-ASCII (7-bit)",                                                                                        \
        20261,  "X-CP-20261",        "T.61",                                                                                                    \
        20269,  "X-CP-20269",        "ISO 6937 Non-Spacing Accent",                                                                             \
        20273,  "IBM-273",           "IBM EBCDIC Germany",                                                                                      \
        20277,  "IBM-277",           "IBM EBCDIC Denmark-Norway",                                                                               \
        20278,  "IBM-278",           "IBM EBCDIC Finland-Sweden",                                                                               \
        20280,  "IBM-280",           "IBM EBCDIC Italy",                                                                                        \
        20284,  "IBM-284",           "IBM EBCDIC Latin America-Spain",                                                                          \
        20285,  "IBM-285",           "IBM EBCDIC United Kingdom",                                                                               \
        20290,  "IBM-290",           "IBM EBCDIC Japanese Katakana Extended",                                                                   \
        20297,  "IBM-297",           "IBM EBCDIC France",                                                                                       \
        20420,  "IBM-420",           "IBM EBCDIC Arabic",                                                                                       \
        20423,  "IBM-423",           "IBM EBCDIC Greek",                                                                                        \
        20424,  "IBM-424",           "IBM EBCDIC Hebrew",                                                                                       \
        20833,  "X-EBCDIC-KOEX",     "IBM EBCDIC Korean Extended",                                                                              \
        20838,  "IBM-Thai",          "IBM EBCDIC Thai",                                                                                         \
        20866,  "KOI8-R",            "Russian (KOI8-R)",                                                                                        \
        20871,  "IBM-871",           "IBM EBCDIC Icelandic",                                                                                    \
        20880,  "IBM-880",           "IBM EBCDIC Cyrillic Russian",                                                                             \
        20905,  "IBM-905",           "IBM EBCDIC Turkish",                                                                                      \
        20924,  "IBM-00924",         "IBM EBCDIC Latin 1/Open System (1047 + Euro symbol)",                                                     \
        20932,  "EUC-JP",            "Japanese (JIS 0208-1990 and 0212-1990)",                                                                  \
        20936,  "X-CP-20936",        "Simplified Chinese (GB2312-80)",                                                                          \
        20949,  "X-CP-20949",        "Korean Wansung",                                                                                          \
        21025,  "CP-1025",           "IBM EBCDIC Cyrillic Serbian-Bulgarian",                                                                   \
        21866,  "KOI8-U",            "Ukrainian (KOI8-U)",                                                                                      \
        28591,  "ISO-8859-1",        "ISO 8859-1 Latin 1",                                                                                      \
        28592,  "ISO-8859-2",        "ISO 8859-2 Central European",                                                                             \
        28593,  "ISO-8859-3",        "ISO 8859-3 Latin 3",                                                                                      \
        28594,  "ISO-8859-4",        "ISO 8859-4 Baltic",                                                                                       \
        28595,  "ISO-8859-5",        "ISO 8859-5 Cyrillic",                                                                                     \
        28596,  "ISO-8859-6",        "ISO 8859-6 Arabic",                                                                                       \
        28597,  "ISO-8859-7",        "ISO 8859-7 Greek",                                                                                        \
        28598,  "ISO-8859-8",        "ISO 8859-8 Hebrew",                                                                                       \
        28599,  "ISO-8859-9",        "ISO 8859-9 Turkish",                                                                                      \
        28603,  "ISO-8859-13",       "ISO 8859-13 Estonian",                                                                                    \
        28605,  "ISO-8859-15",       "ISO 8859-15 Latin 9",                                                                                     \
        29001,  "X-Europa",          "Europa 3",                                                                                                \
        38598,  "ISO-8859-8-i",      "ISO 8859-8 Hebrew",                                                                                       \
        50220,  "ISO-2022-JP",       "ISO 2022 Japanese with no halfwidth Katakana",                                                            \
        50221,  "CS-ISO-2022-JP",    "ISO 2022 Japanese with halfwidth Katakana)",                                                              \
        50222,  "ISO-2022-JP",       "ISO 2022 Japanese JIS X 0201-1989",                                                                       \
        50225,  "ISO-2022-KR",       "ISO 2022 Korean",                                                                                         \
        50227,  "X-CP-50227",        "ISO 2022 Simplified Chinese",                                                                             \
        50229,  "ISO-2022-TRCH",     "ISO 2022 Traditional Chinese",                                                                            \
        50930,  "EBCDIC-ja",         "EBCDIC Japanese (Katakana) Extended",                                                                     \
        50931,  "EBCDIC-US-CA-JA",   "EBCDIC US-Canada and Japanese",                                                                           \
        50933,  "EBCDIC-KO-EXT",     "EBCDIC Korean Extended and Korean",                                                                       \
        50935,  "EBCDIC-SIMCH-EX",   "EBCDIC Simplified Chinese Extended and Simplified Chinese",                                               \
        50936,  "EBCDIC-SIMCH",      "EBCDIC Simplified Chinese",                                                                               \
        50937,  "EBCDIC-us-ca-trch", "EBCDIC US-Canada and Traditional Chinese",                                                                \
        50939,  "EBCDIC-ja-ex",      "EBCDIC Japanese (Latin) Extended and Japanese",                                                           \
        51932,  "EUC-jp",            "EUC Japanese",                                                                                            \
        51936,  "EUC-CN",            "EUC Simplified Chinese",                                                                                  \
        51949,  "EUC-kr",            "EUC Korean",                                                                                              \
        51950,  "EUC-trch",          "EUC Traditional Chinese",                                                                                 \
        52936,  "HZ-GB-2312",        "Chinese Simplified (HZ)",                                                                                 \
        54936,  "GB-18030",          "Chinese Simplified (GB18030)",                                                                            \
        57002,  "X-ISCII-DE",        "ISCII Devanagari",                                                                                        \
        57003,  "X-ISCII-BE",        "ISCII Bangla",                                                                                            \
        57004,  "X-ISCII-TA",        "ISCII Tamil",                                                                                             \
        57005,  "X-ISCII-TE",        "ISCII Telugu",                                                                                            \
        57006,  "X-ISCII-AS",        "ISCII Assamese",                                                                                          \
        57007,  "X-ISCII-OR",        "ISCII Odia",                                                                                              \
        57008,  "X-ISCII-KA",        "ISCII Kannada",                                                                                           \
        57009,  "X-ISCII-MA",        "ISCII Malayalam",                                                                                         \
        57010,  "X-ISCII-GU",        "ISCII Gujarati",                                                                                          \
        57011,  "X-ISCII-PA",        "ISCII Punjabi",                                                                                           \
        65000,  "UTF-7",             "Unicode (UTF-7)"

