;<ff
Window frmConvertANSI, 3, 0, 'TForm', 'Convert ANSI text', $2CD0000, $10001, 0, 530, 209, 640, 480, ConvertWinProc;
Window NONE, 0, 0, 'LISTBOX', 'Listbox', $54A10541, $200, 200, 8, 72, 128, 320, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $54010001, $0, 1, 456, 408, 64, 25, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $54010000, $0, 2, 528, 408, 64, 25, 0;
Window NONE, 0, 0, 'ASMEDIT', 'AsmEdit', $54300127, $200, 201, 152, 72, 464, 320, 0;
Window NONE, 0, 0, 'STATIC', 'Preview:', $54000000, $0, 102, 144, 56, 120, 16, 0;
Window NONE, 0, 0, 'STATIC', 'Code page:', $54000000, $0, 101, 8, 56, 120, 16, 0;
Window NONE, 0, 0, 'EDIT', 'The file you are trying to open is not encoded in UTF-8 and will be converted. Select appropriate code page for the conversion and verify the result in the preview field.', $54000804, $0, 100, 10, 0, 608, 48, 0;
Window NONE, 2, 0, 'EDIT', '', $54000804, $200, 202, 16, 400, 344, 25, 0;
;ff>


iglobal
  SplitStart PreviewLayout
    Split stVert or stJustGap, 8, 40, 0, 100
      Cell cellMessage
      Split stVert or stJustGap or stOriginBR, 8, 25, 0, 100
        Split stHoriz or stJustGap, 8, 200, 0, 200
          Split stVert or stJustGap, 4, 16, 0, 100
            Cell cellLabelLeft
            Cell cellListbox
          Split stVert or stJustGap, 4, 16, 0, 100
            Cell cellLabelRight
            Cell cellPreview
        Split stHoriz or stOriginBR or stJustGap, 8, 64, 0, 100
          Split stHoriz or stOriginBR or stJustGap, 8, 64, 0, 100
            Cell cellDetails
            Cell cellBtnOK
          Cell cellBtnCancel
  SplitEnd


  property propTextPtr, "TextPtr"
  property propTextLen, "TextLen"
  property propCodePage, "CodePage"


endg





proc SelectANSIEncoding, .pText, .len
begin
        pushad

        stdcall CreateForm, frmConvertANSI, [hMainForm]


        invoke  SetPropW, ebx, [propTextPtr], [.pText]
        invoke  SetPropW, ebx, [propTextLen], [.len]

        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .cancel

        invoke  GetPropW, ebx, [propCodePage]
        test    eax, eax
        jz      .cancel

        mov     [esp+4*regEAX], eax
        clc
        popad
        return


.cancel:
        stc
        popad
        return
endp







proc ConvertWinProc, .hwnd, .wmsg, .wparam, .lparam
begin
        dispatch [.wmsg]

.ondefault:
        stc
        return

;------------------------------------------------------------------

oncase SGM_REALIGN

        stdcall OnRealignWithPadding, [.hwnd], 8, 8, 8, 8

        clc
        return


;------------------------------------------------------------------


oncase WM_COMMAND

        cmp     word [.wparam+2], LBN_SELCHANGE
        jne     .ondefault


        invoke  SendMessageW, [.lparam], LB_GETCURSEL, 0, 0
        test    eax, eax
        js      .end_event

        invoke  SendMessageW, [.lparam], LB_GETITEMDATA, eax, 0
        cmp     eax, LB_ERR
        je      .end_event

        stdcall __SetEncodingPreview, [.hwnd], eax

.end_event:
        clc
        return


;------------------------------------------------------------------

oncase WM_INITDIALOG

        invoke  GetDlgItem, [.hwnd], 200
        mov     ebx, eax

        invoke  SendMessageW, ebx, LB_GETCURSEL, 0, 0
        invoke  SendMessageW, [.hwnd], WM_COMMAND, LBN_SELCHANGE shl 16 + 200, ebx

        invoke  SetFocus, ebx

        clc
        return


oncase FM_AFTERCREATE
locals
 .defaultcp dd ?
endl

        stdcall SetSplitGrid, [.hwnd], PreviewLayout

        stdcall AttachToCellDlgItem, [.hwnd], 100, PreviewLayout.cellMessage
        stdcall AttachToCellDlgItem, [.hwnd], 101, PreviewLayout.cellLabelLeft
        stdcall AttachToCellDlgItem, [.hwnd], 102, PreviewLayout.cellLabelRight
        stdcall AttachToCellDlgItem, [.hwnd], 200, PreviewLayout.cellListbox
        stdcall AttachToCellDlgItem, [.hwnd], 201, PreviewLayout.cellPreview
        stdcall AttachToCellDlgItem, [.hwnd], 202, PreviewLayout.cellDetails
        stdcall AttachToCellDlgItem, [.hwnd], 1, PreviewLayout.cellBtnOK
        stdcall AttachToCellDlgItem, [.hwnd], 2, PreviewLayout.cellBtnCancel

; set the AsmEdit theme.

        invoke  GetDlgItem, [.hwnd], 201
        stdcall ApplySettingsToAsmEdit, eax, [CurrentSettings], 0

; fill the listbox.

        invoke  GetACP
        mov     edi, eax
        or      [.defaultcp], -1

        mov     esi, cAllEncodings
        invoke  GetDlgItem, [.hwnd], 200        ; the listbox.
        mov     ebx, eax

.loop:
        cmp     dword [esi], 0
        je      .end_add

        invoke  SendMessageW, ebx, LB_ADDSTRING, edi, [esi+4]
        test    eax, eax
        js      .end_add

        cmp     [esi], edi      ; is it the default CP?
        jne     .default_ok

        mov     [.defaultcp], eax

.default_ok:
        invoke  SendMessageW, ebx, LB_SETITEMDATA, eax, esi

        add     esi, 12
        jmp     .loop

.end_add:

        cmp     [.defaultcp], -1
        je      .finish

        invoke  SendMessageW, ebx, LB_SETCURSEL, [.defaultcp], 0
        invoke  SendMessageW, ebx, LB_SETTOPINDEX, [.defaultcp], 0

.finish:
        clc
        return


        enddispatch
endp



uglobal
  EncodingPreviewBuffer rw 8192
endg





proc __SetEncodingPreview, .hParent, .pEncoding, .pBuffer
begin
        pushad

        mov     esi, [.pEncoding]

; first set the detailed description of the encoding

        invoke  SendDlgItemMessageW, [.hParent], 202, WM_SETTEXT, 0, [esi+8]

; Write it as a result

        invoke  SetPropW, [.hParent], [propCodePage], [esi]

; Then the preview text.

        invoke  GetPropW, [.hParent], [propTextLen]
        mov     ebx,eax
        test    eax, eax
        jz      .finish

        mov     eax, 6*1024
        cmp     ebx, eax
        cmova   ebx, eax        ; maximal size of the preview.


        invoke  GetPropW, [.hParent], [propTextPtr]
        mov     edi, eax
        test    eax, eax
        jz      .finish

        invoke  MultiByteToWideChar, [esi], 0, edi, ebx, EncodingPreviewBuffer, 8192
        test    eax, eax
        jz      .finish

        mov     dword [EncodingPreviewBuffer+2*eax], 0
        invoke  SendDlgItemMessageW, [.hParent], 201, WM_SETTEXT, 0, EncodingPreviewBuffer


.finish:
        popad
        return

.error_free:
        jmp     .finish

endp
